/*	battle.c -- ljsdcdev
	Battle system
	ljsdcdev
	Copyright (C) 2002, 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

static time_t time1;
//static plx_texture_t * bgimage;
static int sel = 0;
static int sel1 = 0;
static float col;
static int bat_done = 0;
static int exper = 0;
static int goldplus = 0;
static stat_data_t * p[13];
static int en_menu[9] = { -1, -1, -1, -1, -1, -1, -1, -1, -1};

static void bat_message(float posx, float posy, float sizex, char * message)	{
	ljsdcdev_line_tr(posx - 16, posy, posx, posy - 16, 255, 255, 255, 255);
	ljsdcdev_line_tr(posx, posy + 32, posx - 16, posy + 16, 255, 255, 255, 255);
	ljsdcdev_line_tr(posx + sizex, posy, posx + sizex - 16, posy - 16, 255, 255, 255, 255);
	ljsdcdev_line_tr(posx + sizex - 16, posy + 32, posx + sizex, posy + 16, 255, 255, 255, 255);
	ljsdcdev_vline_tr(posx - 16, posy, posy + 16, 255, 255, 255, 255);
	ljsdcdev_vline_tr(posx +sizex, posy, posy + 16, 255, 255, 255, 255);
	ljsdcdev_hline_tr(posx, posx + sizex - 16, posy - 16, 255, 255, 255, 255);
	ljsdcdev_hline_tr(posx, posx + sizex - 16, posy + 32, 255, 255, 255, 255);
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, posx, posy + 16.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, message);
	plx_fcxt_end(fcxt_ax);
}

static void bat_draw_ur()	{
	ljsdcdev_line_tr(304, 32, 288, 16, 255, 255, 255, 255);
	ljsdcdev_line_tr(496, 32, 480, 16, 255, 255, 255, 255);
	ljsdcdev_line_tr(624, 48, 608, 32, 255, 255, 255, 255);
	ljsdcdev_line_tr(624, 165, 608, 149, 255, 255, 255, 255);
	ljsdcdev_line_tr(624, 282, 608, 266, 255, 255, 255, 255);
	ljsdcdev_line_tr(624, 399, 608, 383, 255, 255, 255, 255);
}

static void bat_draw_lr()	{
	ljsdcdev_line_tr(288, 288, 304, 272, 255, 255, 255, 255);
	ljsdcdev_line_tr(480, 288, 496, 272, 255, 255, 255, 255);
	ljsdcdev_line_tr(608, 117, 624, 101, 255, 255, 255, 255);
	ljsdcdev_line_tr(608, 234, 624, 218, 255, 255, 255, 255);
	ljsdcdev_line_tr(608, 351, 624, 335, 255, 255, 255, 255);
	ljsdcdev_line_tr(608, 468, 624, 452, 255, 255, 255, 255);
}

static void bat_draw_horiz()	{
	ljsdcdev_hline_tr(32, 288, 16, 255, 255, 255, 255);
	ljsdcdev_hline_tr(352, 480, 16, 255, 255, 255, 255);
	ljsdcdev_hline_tr(32, 288, 288, 255, 255, 255, 255);
	ljsdcdev_hline_tr(352, 480, 288, 255, 255, 255, 255);
	ljsdcdev_hline_tr(544, 608, 32, 255, 255, 255, 255);
	ljsdcdev_hline_tr(544, 608, 117, 255, 255, 255, 255);
	ljsdcdev_hline_tr(544, 608, 149, 255, 255, 255, 255);
	ljsdcdev_hline_tr(544, 608, 234, 255, 255, 255, 255);
	ljsdcdev_hline_tr(544, 608, 265, 255, 255, 255, 255);
	ljsdcdev_hline_tr(544, 608, 351, 255, 255, 255, 255);
	ljsdcdev_hline_tr(544, 608, 383, 255, 255, 255, 255);
	ljsdcdev_hline_tr(544, 608, 468, 255, 255, 255, 255);
}

static void bat_draw_ll()	{
	ljsdcdev_line_tr(32, 288, 16, 272, 255, 255, 255, 255);
	ljsdcdev_line_tr(352, 288, 336, 272, 255, 255, 255, 255);
	ljsdcdev_line_tr(544, 117, 528, 101, 255, 255, 255, 255);
	ljsdcdev_line_tr(544, 234, 528, 218, 255, 255, 255, 255);
	ljsdcdev_line_tr(544, 351, 528, 335, 255, 255, 255, 255);
	ljsdcdev_line_tr(544, 467, 528, 452, 255, 255, 255, 255);
}

static void bat_draw_vert()	{
	ljsdcdev_vline_tr(16, 32, 272, 255, 255, 255, 255);
	ljsdcdev_vline_tr(304, 32, 272, 255, 255, 255, 255);
	ljsdcdev_vline_tr(336, 32, 272, 255, 255, 255, 255);
	ljsdcdev_vline_tr(496, 32, 272, 255, 255, 255, 255);
	ljsdcdev_vline_tr(528, 48, 101, 255, 255, 255, 255);
	ljsdcdev_vline_tr(624, 48, 101, 255, 255, 255, 255);
	ljsdcdev_vline_tr(528, 165, 218, 255, 255, 255, 255);
	ljsdcdev_vline_tr(624, 165, 218, 255, 255, 255, 255);
	ljsdcdev_vline_tr(528, 282, 335, 255, 255, 255, 255);
	ljsdcdev_vline_tr(624, 282, 335, 255, 255, 255, 255);
	ljsdcdev_vline_tr(528, 399, 452, 255, 255, 255, 255);
	ljsdcdev_vline_tr(624, 399, 452, 255, 255, 255, 255);
}

static void bat_draw_ul()	{
	ljsdcdev_line_tr(16, 32, 32, 16, 255, 255, 255, 255);
	ljsdcdev_line_tr(336, 32, 352, 16, 255, 255, 255, 255);
	ljsdcdev_line_tr(528, 48, 544, 32, 255, 255, 255, 255);
	ljsdcdev_line_tr(528, 165, 544, 149, 255, 255, 255, 255);
	ljsdcdev_line_tr(528, 282, 544, 266, 255, 255, 255, 255);
	ljsdcdev_line_tr(528, 399, 544, 383, 255, 255, 255, 255);
}

static void bat_draw_player()	{
	if(stats[0].stats.hp_rem != 0)	{
		plx_txr_send_hdr(stats[0].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 32.0f, 32.0f, 464.0f, 64.0f, 5.0f, 1.0f, 1, 1, 1);
	}
	if(stats[1].stats.hp_rem != 0)	{
		plx_txr_send_hdr(stats[1].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 32.0f, 32.0f, 464.0f, 120.0f, 5.0f, 1.0f, 1, 1, 1);
	}
	if(stats[2].stats.hp_rem != 0)	{
		plx_txr_send_hdr(stats[2].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 32.0f, 32.0f, 464.0f, 176.0f, 5.0f, 1.0f, 1, 1, 1);
	}
	if(stats[3].stats.hp_rem != 0)	{
		plx_txr_send_hdr(stats[3].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 32.0f, 32.0f, 464.0f, 232.0f, 5.0f, 1.0f, 1, 1, 1);
	}
}

static void bat_draw_menu()	{
	ljsdcdev_line_tr(16, 320, 32, 304, 255, 255, 255, 255);
	ljsdcdev_line_tr(184, 320, 200, 304, 255, 255, 255, 255);
	ljsdcdev_line_tr(32, 468, 16, 452, 255, 255, 255, 255);
	ljsdcdev_line_tr(200, 468, 184, 452, 255, 255, 255, 255);
	ljsdcdev_line_tr(168, 320, 152, 304, 255, 255, 255, 255);
	ljsdcdev_line_tr(496, 320, 480, 304, 255, 255, 255, 255);
	ljsdcdev_line_tr(152, 468, 168, 452, 255, 255, 255, 255);
	ljsdcdev_line_tr(480, 468, 496, 452, 255, 255, 255, 255);
	ljsdcdev_vline_tr(16, 320, 452, 255, 255, 255, 255);
	ljsdcdev_vline_tr(168, 320, 452, 255, 255, 255, 255);
	ljsdcdev_vline_tr(184, 320, 452, 255, 255, 255, 255);
	ljsdcdev_vline_tr(496, 320, 452, 255, 255, 255, 255);
	ljsdcdev_hline_tr(32, 152, 304, 255, 255, 255, 255);
	ljsdcdev_hline_tr(32, 152, 468, 255, 255, 255, 255);
	ljsdcdev_hline_tr(200, 480, 304, 255, 255, 255, 255);
	ljsdcdev_hline_tr(200, 480, 468, 255, 255, 255, 255);
	ljsdcdev_arrow(col, 340 + (sel1 * 20), col, 320 + (sel1 * 20), col + 16, 330 + (sel1 * 20), 255, 255, 255, 255);
}

static void bat_draw_mp()	{
	char mpc[10];

	plx_fcxt_setsize(fcxt_ax, 12.0f);
	plx_fcxt_begin(fcxt_ax);
	sprintf(mpc, "%d/%d", stats[0].stats.mp_rem, stats[0].stats.mp);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 96.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, mpc);
	sprintf(mpc, "%d/%d", stats[1].stats.mp_rem, stats[1].stats.mp);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 214.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, mpc);
	sprintf(mpc, "%d/%d", stats[2].stats.mp_rem, stats[2].stats.mp);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 331.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, mpc);
	sprintf(mpc, "%d/%d", stats[3].stats.mp_rem, stats[3].stats.mp);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 446.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, mpc);
 	plx_fcxt_end(fcxt_ax);
}

static void bat_draw_hp()	{
	char hpc[10];
	plx_fcxt_setsize(fcxt_ax, 12.0f);
	plx_fcxt_begin(fcxt_ax);
	sprintf(hpc, "%d/%d", stats[0].stats.hp_rem, stats[0].stats.hp);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 80.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, hpc);
	sprintf(hpc, "%d/%d", stats[1].stats.hp_rem, stats[1].stats.hp);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 198.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, hpc);
	sprintf(hpc, "%d/%d", stats[2].stats.hp_rem, stats[2].stats.hp);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 315.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, hpc);
	sprintf(hpc, "%d/%d", stats[3].stats.hp_rem, stats[3].stats.hp);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 432.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, hpc);
	plx_fcxt_end(fcxt_ax);
}

static void bat_draw_names()	{
	plx_fcxt_setsize(fcxt_ax, 12.0f);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 60.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, stats[0].name);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 177.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, stats[1].name);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 294.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, stats[2].name);
	plx_fcxt_setpos(fcxt_ax, 544.0f, 411.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, stats[3].name);
	plx_fcxt_end(fcxt_ax);
}

static void bat_draw_options()	{
	plx_fcxt_setsize(fcxt_ax, 20.0f);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setcolor4f(fcxt_ax, 1.0f, 1.0f, 1.0f, 1.0f);
	plx_fcxt_setpos(fcxt_ax, 64.0f, 340.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Attack");
	plx_fcxt_setpos(fcxt_ax, 64.0f, 360.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Magic");
	plx_fcxt_setpos(fcxt_ax, 64.0f, 380.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Skill");
	plx_fcxt_setpos(fcxt_ax, 64.0f, 400.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Item");
	plx_fcxt_setpos(fcxt_ax, 64.0f, 420.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Defend");
	plx_fcxt_setpos(fcxt_ax, 64.0f, 440.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Run");
	plx_fcxt_end(fcxt_ax);
}

static void bat_draw_enemyn()	{
	int x = 232;
	int y = 340;
	int i, j = 0;

	plx_fcxt_setsize(fcxt_ax, 20.0f);
	plx_fcxt_begin(fcxt_ax);

	for(i = 0; i < 9; i++)
		en_menu[i] = -1;

	for(i = 0; i < 9; i++)	{
		if(enemies[i].stats.hp_rem != 0)	{
			plx_fcxt_setpos(fcxt_ax, x, y, 5.0f);
			plx_fcxt_draw(fcxt_ax, enemies[i].name);
			y += 20;
			if(y > 420)	{
				y = 340;
				x = 364;
			}
			en_menu[j] = i;
			j++;
		}
	}
}

static void bat_draw_enemies()	{
	if(enemies[0].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[0].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 85.0f, 85.0f, 5.0f, 1.0f, 1, 1, 1);
	}

	if(enemies[1].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[1].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 85.0f, 159.0f, 5.0f, 1.0f, 1, 1, 1);
	}

	if(enemies[2].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[2].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 85.0f, 233.0f, 5.0f, 1.0f, 1, 1, 1);
	}

	if(enemies[3].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[3].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 164.0f, 85.0f, 5.0f, 1.0f, 1, 1, 1);
	}

	if(enemies[4].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[4].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 164.0f, 159.0f, 5.0f, 1.0f, 1, 1, 1);
	}

	if(enemies[5].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[5].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 164.0f, 233.0f, 5.0f, 1.0f, 1, 1, 1);
	}

	if(enemies[6].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[6].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 243.0f, 85.0f, 5.0f, 1.0f, 1, 1, 1);
	}

	if(enemies[7].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[7].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 243.0f, 159.0f, 5.0f, 1.0f, 1, 1, 1);
	}

	if(enemies[8].stats.hp_rem != 0)	{
		plx_txr_send_hdr(enemies[8].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 72.0f, 72.0f, 243.0f, 233.0f, 5.0f, 1.0f, 1, 1, 1);
	}

}


static inline void bat_draw_indic(stat_data_t * astat)	{
	int i, pos;
	for(i = 0; i < 4; i++)	{
		if(astat == &stats[i])	{
			break;
		}
	}

	pos = 54 + (i * 56);

	ljsdcdev_arrow(432, pos + 20, 432, pos, 448, pos+10, 255, 0xFF, 0xFF, 0xFF);
}

static void bat_show_term(stat_data_t * def, stat_data_t * att)	{
	ljsdcdev_line_tr(184, 452, 200, 436, 255, 255, 255, 255);
	ljsdcdev_line_tr(200, 468, 184, 452, 255, 255, 255, 255);
	ljsdcdev_line_tr(386, 452, 370, 436, 255, 255, 255, 255);
	ljsdcdev_line_tr(370, 468, 386, 452, 255, 255, 255, 255);
	ljsdcdev_hline_tr(200, 370, 436, 255, 255, 255, 255);
	ljsdcdev_hline_tr(200, 370, 468, 255, 255, 255, 255);

	plx_fcxt_setsize(fcxt_ax, 16.0f);
	plx_fcxt_begin(fcxt_ax);

	plx_fcxt_setpos(fcxt_ax, 216.0f, 458.0f, 5.0f);

	if(def->ally == -1)	{
		plx_fcxt_draw(fcxt_ax, "Terminated");
	}

	else if(def->ally == 1)	{
		plx_fcxt_draw(fcxt_ax, "Slain");
	}

	plx_fcxt_end(fcxt_ax);
}

static void bat_show_damage(unsigned int damage, stat_data_t *att, stat_data_t *def)	{
	char string[40];

	plx_scene_begin();
	plx_list_begin(PLX_LIST_OP_POLY);
	plx_list_begin(PLX_LIST_TR_POLY);
	bat_draw_names();
	bat_draw_hp();
	bat_draw_mp();

	bat_message(32.0f, 320.0f, 136.0f, att->name);
	ljsdcdev_line_tr(184, 320, 200, 304, 255, 255, 255, 255);
	ljsdcdev_line_tr(184, 380, 200, 364, 255, 255, 255, 255);
	ljsdcdev_line_tr(200, 352, 184, 336, 255, 255, 255, 255);
	ljsdcdev_line_tr(200, 412, 184, 395, 255, 255, 255, 255);
	ljsdcdev_line_tr(386, 320, 370, 304, 255, 255, 255, 255);
	ljsdcdev_line_tr(386, 380, 370, 364, 255, 255, 255, 255);
	ljsdcdev_line_tr(370, 352, 386, 336, 255, 255, 255, 255);
	ljsdcdev_line_tr(370, 412, 386, 396, 255, 255, 255, 255);
	ljsdcdev_vline_tr(184, 320, 336, 255, 255, 255, 255);
	ljsdcdev_vline_tr(386, 320, 336, 255, 255, 255, 255);
	ljsdcdev_vline_tr(184, 380, 396, 255, 255, 255, 255);
	ljsdcdev_vline_tr(386, 380, 396, 255, 255, 255, 255);
	ljsdcdev_hline_tr(200, 370, 304, 255, 255, 255, 255);
	ljsdcdev_hline_tr(200, 370, 352, 255, 255, 255, 255);
	ljsdcdev_hline_tr(200, 370, 364, 255, 255, 255, 255);
	ljsdcdev_hline_tr(200, 370, 412, 255, 255, 255, 255);

	plx_fcxt_setsize(fcxt_ax, 16.0f);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 216.0f, 334.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, def->name);
	plx_fcxt_setpos(fcxt_ax, 216.0f, 394.0f, 5.0f);
	if(damage > 1)
		sprintf(string, "%d damages", damage);

	if(damage == 1)
		sprintf(string, "%d damage", damage);

	plx_fcxt_draw(fcxt_ax, string);
	plx_fcxt_end(fcxt_ax);

	if(damage >= def->stats.hp_rem)
		bat_show_term(def, att);

	bat_draw_ul();
	bat_draw_vert();
	bat_draw_ll();
	bat_draw_horiz();
	bat_draw_lr();
	bat_draw_ur();
	bat_draw_enemies();
	bat_draw_player();
	plx_scene_end();
}

static void bat_draw_mname(stat_data_t * character)	{
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	if(character->magic.mag_lev1[0] != 0)	{
		if(magics[(character->magic.mag_lev1[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev1[0] - 1)].name, 204, 340, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev1[0] - 1)].name, 204, 340, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev1[1] != 0)	{
		if(magics[(character->magic.mag_lev1[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev1[1] - 1)].name, 278, 340, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev1[1] - 1)].name, 278, 340, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev1[2] != 0)	{
		if(magics[(character->magic.mag_lev1[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev1[2] - 1)].name, 352, 340, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev1[2] - 1)].name, 352, 340, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev1[3] != 0)	{
		if(magics[(character->magic.mag_lev1[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev1[3] - 1)].name, 426, 340, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev1[3] - 1)].name, 426, 340, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev2[0] != 0)	{
		if(magics[(character->magic.mag_lev2[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev2[0] - 1)].name, 204, 364, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev2[0] - 1)].name, 204, 364, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev2[1] != 0)	{
		if(magics[(character->magic.mag_lev2[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev2[1] - 1)].name, 278, 364, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev2[1] - 1)].name, 278, 364, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev2[2] != 0)	{
		if(magics[(character->magic.mag_lev2[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev2[2] - 1)].name, 352, 366, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev2[2] - 1)].name, 352, 364, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev2[3] != 0)	{
		if(magics[(character->magic.mag_lev2[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev2[3] - 1)].name, 426, 364, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev2[3] - 1)].name, 426, 364, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev3[0] != 0)	{
		if(magics[(character->magic.mag_lev3[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev3[0] - 1)].name, 204, 388, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev3[0] - 1)].name, 204, 388, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev3[1] != 0)	{
		if(magics[(character->magic.mag_lev3[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev3[1] - 1)].name, 278, 388, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev3[1] - 1)].name, 278, 388, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev3[2] != 0)	{
		if(magics[(character->magic.mag_lev3[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev3[2] - 1)].name, 352, 388, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev3[2] - 1)].name, 352, 388, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev3[3] != 0)	{
		if(magics[(character->magic.mag_lev3[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev3[3] - 1)].name, 426, 388, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev3[3] - 1)].name, 426, 388, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev4[0] != 0)	{
		if(magics[(character->magic.mag_lev4[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev4[0] - 1)].name, 204, 412, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev4[0] - 1)].name, 204, 412, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev4[1] != 0)	{
		if(magics[(character->magic.mag_lev4[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev4[1] - 1)].name, 278, 412, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev4[1] - 1)].name, 278, 412, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev4[2] != 0)	{
		if(magics[(character->magic.mag_lev4[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev4[2] - 1)].name, 352, 412, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev4[2] - 1)].name, 352, 412, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev4[3] != 0)	{
		if(magics[(character->magic.mag_lev4[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev4[3] - 1)].name, 426, 412, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev4[3] - 1)].name, 426, 412, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev5[0] != 0)	{
		if(magics[(character->magic.mag_lev5[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev5[0] - 1)].name, 204, 436, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev5[0] - 1)].name, 204, 436, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev5[1] != 0)	{
		if(magics[(character->magic.mag_lev5[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev5[1] - 1)].name, 278, 436, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev5[1] - 1)].name, 278, 436, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev5[2] != 0)	{
		if(magics[(character->magic.mag_lev5[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev5[2] - 1)].name, 352, 436, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev5[2] - 1)].name, 352, 436, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev5[3] != 0)	{
		if(magics[(character->magic.mag_lev5[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev5[3] - 1)].name, 426, 436, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev5[3] - 1)].name, 426, 436, 255, 128, 128, 128);
		}
	}

	plx_fcxt_setcolor4f(fcxt_ax, 1.0f, 1.0f, 1.0f, 1.0f);
}

static void bat_draw_mname2(stat_data_t * character)	{
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	if(character->magic.mag_lev6[0] != 0)	{
		if(magics[(character->magic.mag_lev6[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev6[0] - 1)].name, 204, 340, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev6[0] - 1)].name, 204, 340, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev6[1] != 0)	{
		if(magics[(character->magic.mag_lev6[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev6[1] - 1)].name, 278, 340, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev6[1] - 1)].name, 278, 340, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev6[2] != 0)	{
		if(magics[(character->magic.mag_lev6[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev6[2] - 1)].name, 352, 340, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev6[2] - 1)].name, 352, 340, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev6[3] != 0)	{
		if(magics[(character->magic.mag_lev6[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev6[3] - 1)].name, 426, 340, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev6[3] - 1)].name, 426, 340, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev7[0] != 0)	{
		if(magics[(character->magic.mag_lev7[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev7[0] - 1)].name, 204, 364, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev7[0] - 1)].name, 204, 364, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev7[1] != 0)	{
		if(magics[(character->magic.mag_lev7[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev7[1] - 1)].name, 278, 364, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev7[1] - 1)].name, 278, 364, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev7[2] != 0)	{
		if(magics[(character->magic.mag_lev7[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev7[2] - 1)].name, 352, 366, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev7[2] - 1)].name, 352, 364, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev7[3] != 0)	{
		if(magics[(character->magic.mag_lev7[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev7[3] - 1)].name, 426, 364, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev7[3] - 1)].name, 426, 364, 255, 128, 128, 128);
		}
 }
	if(character->magic.mag_lev8[0] != 0)	{
		if(magics[(character->magic.mag_lev8[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev8[0] - 1)].name, 204, 388, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev8[0] - 1)].name, 204, 388, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev8[1] != 0)	{
		if(magics[(character->magic.mag_lev8[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev8[1] - 1)].name, 278, 388, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev8[1] - 1)].name, 278, 388, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev8[2] != 0)	{
		if(magics[(character->magic.mag_lev8[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev8[2] - 1)].name, 352, 388, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev8[2] - 1)].name, 352, 388, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev8[3] != 0)	{
		if(magics[(character->magic.mag_lev8[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev8[3] - 1)].name, 426, 388, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev8[3] - 1)].name, 426, 388, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev9[0] != 0)	{
		if(magics[(character->magic.mag_lev9[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev9[0] - 1)].name, 204, 412, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev9[0] - 1)].name, 204, 412, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev9[1] != 0)	{
		if(magics[(character->magic.mag_lev9[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev9[1] - 1)].name, 278, 412, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev9[1] - 1)].name, 278, 412, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev9[2] != 0)	{
		if(magics[(character->magic.mag_lev9[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev9[2] - 1)].name, 352, 412, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev9[2] - 1)].name, 352, 412, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev9[3] != 0)	{
		if(magics[(character->magic.mag_lev9[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev9[3] - 1)].name, 426, 412, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev9[3] - 1)].name, 426, 412, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev10[0] != 0)	{
		if(magics[(character->magic.mag_lev10[0] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev10[0] - 1)].name, 204, 436, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev10[0] - 1)].name, 204, 436, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev10[1] != 0)	{
		if(magics[(character->magic.mag_lev10[1] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev10[1] - 1)].name, 278, 436, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev10[1] - 1)].name, 278, 436, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev10[2] != 0)	{
		if(magics[(character->magic.mag_lev10[2] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev10[2] - 1)].name, 352, 436, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev10[2] - 1)].name, 352, 436, 255, 128, 128, 128);
		}
	}
	if(character->magic.mag_lev10[3] != 0)	{
		if(magics[(character->magic.mag_lev10[3] - 1)].typ < 126)	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev10[3] - 1)].name, 426, 436, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(character->magic.mag_lev10[3] - 1)].name, 426, 436, 255, 128, 128, 128);
		}
	}

	plx_fcxt_setcolor4f(fcxt_ax, 1.0f, 1.0f, 1.0f, 1.0f);

}

static void bat_draw_itname()	{
	char item_name[20];
	int i;
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	for(i = 0; i < 10; i++)	{
		if(itemlist[i].number != 0)	{
			sprintf(item_name, "%s x %d", items[itemlist[i].number - 1].name, itemlist[i].count);
			if(i <= 4)	{
				ljsdcdev_text(fcxt_ax, item_name, 204, 340 + i * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else	{
				ljsdcdev_text(fcxt_ax, item_name, 352, 340 + (i - 5) * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
		}
	}
}

static void bat_draw_itname2()	{
	char item_name[20];
	int i;
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	for(i = 10; i < 20; i++)	{
		if(itemlist[i].number != 0)	{
			sprintf(item_name, "%s x %d", items[itemlist[i].number - 1].name, itemlist[i].count);
			if(i <= 14)	{
				ljsdcdev_text(fcxt_ax, item_name, 204, 340 + (i - 10) * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else	{
				ljsdcdev_text(fcxt_ax, item_name, 352, 340 + (i - 15) * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
		}
	}
}

static void bat_draw_itname3()	{
	char item_name[20];
	int i;
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	for(i = 20; i < 30; i++)	{
		if(itemlist[i].number != 0)	{
			sprintf(item_name, "%s x %d", items[itemlist[i].number - 1].name, itemlist[i].count);
			if(i <= 24)	{
				ljsdcdev_text(fcxt_ax, item_name, 204, 340 + (i - 20) * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else	{
				ljsdcdev_text(fcxt_ax, item_name, 352, 340 + (i - 25) * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
		}
	}
}

static void bat_draw_itname4()	{
	char item_name[20];
	int i;
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	for(i = 30; i < 40; i++)	{
		if(itemlist[i].number != 0)	{
			sprintf(item_name, "%s, x %d", items[itemlist[i].number - 1].name, itemlist[i].count);
			if(i <= 34)	{
				ljsdcdev_text(fcxt_ax, item_name, 204, 340 + (i - 30) * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else	{
				ljsdcdev_text(fcxt_ax, item_name, 352, 340 + (i - 35) * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
		}
	}
}

static void bat_att_damage(stat_data_t * att, stat_data_t * def)	{
	int res, res1;
	int equipa = 0, equipd = 0;
	int i;

	for(i = 0; i < 10; i++)	{
		if(att->ally != -1)	{
			equipa += equipment[att->equip.equipment[i]].att;
		}
		else	{
			equipd += equipment[def->equip.equipment[i]].def;
		}
	}

	res = ljsdcdev_random(att->stats.attack + equipa, (att->stats.attack + equipa) * 2) - (def->stats.defense + equipd);

	if(res < 1)
		res = 1;

	if(def->battle.defend == 1 && res != 1)
		res /= 2;

	if(res > def->stats.hp_rem)	{
		time1 = time(NULL);
		while(time(NULL) < time1 + 2)
			bat_show_damage(res, att, def);
		def->stats.hp_rem = 0;
		if(att->ally == 1)	{
			att->bat.kills++;
			att->stats.sxp += def->stats.sxp;
			exper += def->stats.exp;
			goldplus += def->stats.gold;
		}
		else if(def->ally == 1)	{
			def->bat.defeats++;
			def->stats.sxp /= 2;
		}
	}
	else	{
		time1 = time(NULL);
		while(time(NULL) < time1 + 2)
			bat_show_damage(res, att, def);
		res1 = def->stats.hp_rem - res;
		def->stats.hp_rem = res1;
	}

}

static void bat_defend(stat_data_t * foo)	{
 	plx_scene_begin();
	plx_list_begin(PLX_LIST_OP_POLY);
	plx_list_begin(PLX_LIST_TR_POLY);
	bat_draw_names();
	bat_draw_hp();
	bat_draw_mp();
	bat_draw_ul();
	bat_draw_vert();
	bat_draw_ll();
	bat_draw_horiz();
	bat_draw_lr();
	bat_draw_ur();
	bat_draw_enemies();
	bat_draw_player();
	bat_message(32.0f, 320.0f, 136.0f, foo->name);
	bat_message(202.0f, 320.0f, 136.0f, "Defending");
	plx_scene_end();
}

static void bat_enemy_ai(stat_data_t * estat)	{
	int rand, rand2, ally;
	int i = 0;
	rand = ljsdcdev_random(0, 9);
	rand2 = ljsdcdev_random(0, 7);
	if(estat->stats.speed != 0 && estat->stats.hp_rem != 0)	{
		while(i != estat->stats.speed)	{
			rand = ljsdcdev_random(0, 9);
			i++;
		}
		i = 0;
		if(rand >= 0)	{
			rand2 = ljsdcdev_random(0, 7);

			if(rand2 <= 2)
				ally = 0;
			else if(rand2 <= 4)
				ally = 1;
			else if(rand2 <= 6)
				ally = 2;
			else
				ally = 3;

			while(stats[ally].stats.hp_rem == 0)	{
				if(ally != 0)
					ally -= 1;
				else
					ally = 3;
			}

			bat_att_damage(estat, &stats[ally]);
		}
	}
}

static void bat_run(stat_data_t * astat, stat_data_t * estat)	{
	if(astat->stats.speed >= estat->stats.speed)	{
	 	plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);
		bat_draw_names();
		bat_draw_hp();
		bat_draw_mp();
		bat_draw_ul();
		bat_draw_vert();
		bat_draw_ll();
		bat_draw_horiz();
		bat_draw_lr();
		bat_draw_ur();
		bat_draw_enemies();
		bat_draw_player();
		bat_message(32.0f, 320.0f, 136.0f, astat->name);
		bat_message(202.0f, 320.0f, 136.0f, "Ran Away");
		plx_scene_end();
		bat_done = 1;
	}
	else	{
		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);
		bat_draw_names();
		bat_draw_hp();
		bat_draw_mp();
		bat_draw_ul();
		bat_draw_vert();
		bat_draw_ll();
		bat_draw_horiz();
		bat_draw_lr();
		bat_draw_ur();
		bat_draw_enemies();
		bat_draw_player();
		bat_message(32.0f, 320.0f, 136.0f, astat->name);
		bat_message(202.0f, 320.0f, 136.0f, "Couldn't Run!");
		plx_scene_end();
	}
}

static void bat_magic_use(int magic, stat_data_t * astat, int pl)	{
	time_t time1 = time(NULL);
	char string2[40];
	int res;

	if(astat->stats.mp_rem >= (magics[magic].lev * magics[magic].lev))	{
		if(magics[magic].aff == 1)	{
			if(magics[magic].stat == 1)	{
				res = ljsdcdev_random((magics[magic].str + astat->stats.matt), (int) ((magics[magic].str + astat->stats.matt) * 1.5));
				sprintf(string2, "%d HP", res);
				while(time1 + 2 > time(NULL))	{
					plx_scene_begin();
					plx_list_begin(PLX_LIST_OP_POLY);
					plx_list_begin(PLX_LIST_TR_POLY);
					bat_draw_names();
					bat_draw_hp();
					bat_draw_mp();
					bat_draw_ul();
					bat_draw_vert();
					bat_draw_ll();
					bat_draw_horiz();
					bat_draw_lr();
					bat_draw_ur();
					bat_draw_enemies();
					bat_draw_player();
					bat_message(32.0f, 320.0f, 136.0f, astat->name);
					bat_message(32.0f, 376.0f, 136.0f, magics[magic].name);
					bat_message(202.0f, 320.0f, 170.0f, stats[pl].name);
					bat_message(202.0f, 376.0f, 170.0f, string2);
					plx_scene_end();
				}
				stats[pl].stats.hp_rem += res;
				if(stats[pl].stats.hp_rem > stats[pl].stats.hp)
					stats[pl].stats.hp_rem = stats[pl].stats.hp;
				astat->stats.mp_rem -= (magics[magic].lev * magics[magic].lev);
			}
		}
		else if(magics[magic].aff == 6)	{
			if(magics[magic].stat == 1)	{
				res = ljsdcdev_random((magics[magic].str + astat->stats.matt), (magics[magic].str + astat->stats.matt) * 2) - enemies[pl].stats.mdef;
				if(enemies[pl].stats.hp_rem <= res)	{
					enemies[pl].stats.hp_rem = 0;
					astat->bat.kills++;
					exper += enemies[pl].stats.exp;
					goldplus += enemies[pl].stats.gold;
					astat->stats.sxp += enemies[pl].stats.sxp;
				}
				else	{
					enemies[pl].stats.hp_rem -= res;
				}
				sprintf(string2, "%d damages", res);
				while(time1 + 2 > time(NULL))	{
					plx_scene_begin();
					plx_list_begin(PLX_LIST_OP_POLY);
					plx_list_begin(PLX_LIST_TR_POLY);
					bat_draw_names();
					bat_draw_hp();
					bat_draw_mp();
					bat_draw_ul();
					bat_draw_vert();
					bat_draw_ll();
					bat_draw_horiz();
					bat_draw_lr();
					bat_draw_ur();
					bat_draw_enemies();
					bat_draw_player();
					bat_message(32.0f, 320.0f, 136.0f, astat->name);
					bat_message(32.0f, 376.0f, 136.0f, magics[magic].name);
					bat_message(202.0f, 320.0f, 170.0f, enemies[pl].name);
					bat_message(202.0f, 376.0f, 170.0f, string2);
					if(enemies[pl].stats.hp_rem == 0)
						bat_show_term(&enemies[pl], astat);
					plx_scene_end();
				}
				astat->stats.mp_rem -= (magics[magic].lev * magics[magic].lev);
			}
		}
	}
	thd_sleep(200);
}

static int mx = 0, my = 0, magic_done = 0;
static int ix = 0, iy = 0, item_done = 0;
static int st = 0, sn = 0, skill_done = 0;

static void bat_skill_use(int skill, stat_data_t * astat, int pl)	{
	time_t time1 = time(NULL);
	char string2[40];
	int res;
	int equipa = 0;
	int i;

	for(i = 0; i < 10; i++)	{
		equipa += equipment[astat->equip.equipment[i]].att;
	}

	 if(skills[skill].aff == 6)	{
		if(skills[skill].typ == 1)	{
			res = ljsdcdev_random((astat->stats.attack + equipa) * skills[skill].str, (astat->stats.attack + equipa) * skills[skill].str * 2) - enemies[pl].stats.defense;
			if(enemies[pl].stats.hp_rem <= res)	{
				enemies[pl].stats.hp_rem = 0;
				astat->bat.kills++;
				exper += enemies[pl].stats.exp;
				goldplus += enemies[pl].stats.gold;
				astat->stats.sxp += enemies[pl].stats.sxp;
			}
			else	{
				enemies[pl].stats.hp_rem -= res;
			}
			sprintf(string2, "%d damages", res);
			while(time1 + 2 > time(NULL))	{
				plx_scene_begin();
				plx_list_begin(PLX_LIST_OP_POLY);
				plx_list_begin(PLX_LIST_TR_POLY);
				bat_draw_names();
				bat_draw_hp();
				bat_draw_mp();
				bat_draw_ul();
				bat_draw_vert();
				bat_draw_ll();
				bat_draw_horiz();
				bat_draw_lr();
				bat_draw_ur();
				bat_draw_enemies();
				bat_draw_player();
				bat_message(32.0f, 320.0f, 136.0f, astat->name);
				bat_message(32.0f, 376.0f, 136.0f, skills[skill].name);
				bat_message(202.0f, 320.0f, 170.0f, enemies[pl].name);
				bat_message(202.0f, 376.0f, 170.0f, string2);
				if(enemies[pl].stats.hp_rem == 0)
					bat_show_term(&enemies[pl], astat);
				plx_scene_end();
			}
		}
	}
	thd_sleep(200);
	if(st == 0)	{
		astat->skills.sk_t1_chl[sn]--;
	}
	else if(st == 1)	{
		astat->skills.sk_t2_chl[sn]--;
	}
	else if(st == 2)	{
		astat->skills.sk_t3_chl[sn]--;
	}
	else if(st == 4)	{
		astat->skills.sk_t4_chl[sn]--;
	}
	else	{
		astat->skills.sk_t5_chl[sn]--;
	}
}

static void bat_draw_skillname(stat_data_t * astat)	{
	char skill[50];
	int i;
	uint16 * pt1;
	uint8 * pt2;
	if(st == 0)	{
		pt1 = astat->skills.sk_type1;
		pt2 = astat->skills.sk_t1_chl;
	}
	else if(st == 1)	{
		pt1 = astat->skills.sk_type2;
		pt2 = astat->skills.sk_t2_chl;
	}
	else if(st == 2)	{
		pt1 = astat->skills.sk_type3;
		pt2 = astat->skills.sk_t3_chl;
	}
	else if(st == 3)	{
		pt1 = astat->skills.sk_type4;
		pt2 = astat->skills.sk_t4_chl;
	}
	else	{
		pt1 = astat->skills.sk_type5;
		pt2 = astat->skills.sk_t5_chl;
	}

	plx_fcxt_setsize(fcxt_ax, 20.0f);
	if(sn < 5)	{
		for(i = 0; i < 5; i++)	{
			if(pt1[i] != 0)	{
				sprintf(skill, "%s x %d", skills[pt1[i] - 1].name, pt2[i]);
				ljsdcdev_text(fcxt_ax, skill, 204, 340 + i * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
		}
	}
	else	{
		for(i = 5; i < 10; i++)	{
			if(pt1[i] != 0)	{
				sprintf(skill, "%s x %d", skills[pt1[i] - 1].name, pt2[i]);
				ljsdcdev_text(fcxt_ax, skill, 204, 340 + (i - 5) * 24, 255, options.bc.r, options.bc.g, options.bc.b);
			}
		}
	}
}

static int bat_magic_sel1(stat_data_t * player)	{
	int y = 52;
	cont_state_t * state;
	uint64 time_since = timer_ms_gettime64();

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));
		if(state != NULL)	{
			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				y -= 117;
				if(y > 403)	{
					y = 52;
				}
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				y += 117;
				if(y < 52)	{
					y = 403;
				}
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
				return -1;
			}
			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
				if(stats[(y - 52) / 117].stats.hp_rem != 0)
					return ((y - 52) / 117);
			}
		}
		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);

		bat_draw_names();
		bat_draw_hp();
		bat_draw_mp();
		bat_draw_ul();
		bat_draw_vert();
		bat_draw_ll();
		bat_draw_horiz();
		bat_draw_lr();
		bat_draw_ur();
		bat_draw_enemies();
		bat_draw_menu();
		bat_draw_options();
		if(player != NULL)	{
			if(my < 5)	{
				bat_draw_mname(player);
				ljsdcdev_arrow(mx * 74 + 184, 340 + (my * 24), mx * 74 + 184, 320 + (my * 24), mx * 74 + 200, 330 + (my * 24), 255, 255, 255, 255);
			}
			else	{
				bat_draw_mname2(player);
				ljsdcdev_arrow(mx * 74 + 184, 340 + ((my - 5) * 24), mx * 74 + 184, 320 + ((my - 5) * 24), mx * 74 + 200, 330 + ((my - 5) * 24), 255, 255, 255, 255);
			}
		}
		else	{
			if(iy < 5)	{
				bat_draw_itname();
				ljsdcdev_arrow(ix * 148 + 184, 340 + (iy * 24), ix * 148 + 184, 320 + (iy * 24), ix * 148 + 200, 330 + (iy * 24), 255, 255, 255, 255);
			}

			else if(iy < 10)	{
				bat_draw_itname2();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 5) * 24), ix * 148 + 184, 320 + ((iy - 5) * 24), ix * 148 + 200, 330 + ((iy - 5) * 24), 255, 255, 255, 255);
			}

			else if(iy < 15)	{
				bat_draw_itname3();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 10) * 24), ix * 148 + 184, 320 + ((iy - 10) * 24), ix * 148 + 200, 330 + ((iy - 10) * 24), 255, 255, 255, 255);
			}

			else	{
				bat_draw_itname4();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 15) * 24), ix * 148 + 184, 320 + ((iy - 15) * 24), ix * 148 + 200, 330 + ((iy - 15) * 24), 255, 255, 255, 255);
			}
		}

		ljsdcdev_arrow(512, y + 16, 512, y, 528, y + 8, 255, 255, 255, 255);
		bat_draw_player();
		plx_scene_end();
	}
}

static int bat_magic_sel2(stat_data_t * player)	{
	int y = 69;
	int x = 33;
	cont_state_t * state;
	uint64 time_since = timer_ms_gettime64();

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));
		if(state != NULL)	{
			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				y -= 74;
				if(y < 69)	{
					y = 217;
					x -= 79;
					if(x < 33)
						x = 191;
				}
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				y += 74;
				if(y > 217)	{
					y = 69;
					x += 79;
					if(x > 191)
						x = 33;
				}
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
				return -1;
			}
			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
				if(enemies[((((x - 33) / 79) * 3) + (y - 69) / 74)].stats.hp_rem != 0)
					return ((((x - 33) / 79) * 3) + (y - 69) / 74);
			}
		}
		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);

		bat_draw_names();
		bat_draw_hp();
		bat_draw_mp();
		bat_draw_ul();
		bat_draw_vert();
		bat_draw_ll();
		bat_draw_horiz();
		bat_draw_lr();
		bat_draw_ur();
		bat_draw_enemies();
		bat_draw_menu();
		bat_draw_options();
		if(player != NULL)	{
			if(my < 5)	{
				bat_draw_mname(player);
				ljsdcdev_arrow(mx * 74 + 184, 340 + (my * 24), mx * 74 + 184, 320 + (my * 24), mx * 74 + 200, 330 + (my * 24), 255, 255, 255, 255);
			}
			else	{
				bat_draw_mname2(player);
				ljsdcdev_arrow(mx * 74 + 184, 340 + ((my - 5) * 24), mx * 74 + 184, 320 + ((my - 5) * 24), mx * 74 + 200, 330 + ((my - 5) * 24), 255, 255, 255, 255);
			}
		}
		else	{
			if(iy < 5)	{
				bat_draw_itname();
				ljsdcdev_arrow(ix * 148 + 184, 340 + (iy * 24), ix * 148 + 184, 320 + (iy * 24), ix * 148 + 200, 330 + (iy * 24), 255, 255, 255, 255);
			}

			else if(iy < 10)	{
				bat_draw_itname2();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 5) * 24), ix * 148 + 184, 320 + ((iy - 5) * 24), ix * 148 + 200, 330 + ((iy - 5) * 24), 255, 255, 255, 255);
			}

			else if(iy < 15)	{
				bat_draw_itname3();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 10) * 24), ix * 148 + 184, 320 + ((iy - 10) * 24), ix * 148 + 200, 330 + ((iy - 10) * 24), 255, 255, 255, 255);
			}

			else	{
				bat_draw_itname4();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 15) * 24), ix * 148 + 184, 320 + ((iy - 15) * 24), ix * 148 + 200, 330 + ((iy - 15) * 24), 255, 255, 255, 255);
			}
		}

		ljsdcdev_arrow(x, y + 16, x, y, x + 16, y + 8, 255, 255, 255, 255);
		bat_draw_player();
		plx_scene_end();
	}
}

static void bat_item_use(int num, stat_data_t * astat, int ch)	{
	time_t time1 = time(NULL);
	char string2[40];
	int res;

	if(items[itemlist[num].number - 1].aff == 1)	{
		if(items[itemlist[num].number - 1].eff == 1)	{
			res = items[itemlist[num].number - 1].str;
			sprintf(string2, "%d HP", res);
			while(time1 + 2 > time(NULL))	{
				plx_scene_begin();
				plx_list_begin(PLX_LIST_OP_POLY);
				plx_list_begin(PLX_LIST_TR_POLY);
				bat_draw_names();
				bat_draw_hp();
				bat_draw_mp();
				bat_draw_ul();
				bat_draw_vert();
				bat_draw_ll();
				bat_draw_horiz();
				bat_draw_lr();
				bat_draw_ur();
				bat_draw_enemies();
				bat_draw_player();
				bat_message(32.0f, 320.0f, 136.0f, astat->name);
				bat_message(32.0f, 376.0f, 136.0f, items[itemlist[num].number - 1].name);
				bat_message(202.0f, 320.0f, 170.0f, stats[ch].name);
				bat_message(202.0f, 376.0f, 170.0f, string2);
				plx_scene_end();
			}
			stats[ch].stats.hp_rem += res;
			if(stats[ch].stats.hp_rem > stats[ch].stats.hp)
				stats[ch].stats.hp_rem = stats[ch].stats.hp;
			itemlist[num].count--;
			if(itemlist[num].count == 0)	{
				itemlist[num].count = 0;
				misc_sort_items();
			}
		}
	}
	thd_sleep(200);
}

static void bat_item_sel(stat_data_t * astat)	{
	int ch;
	switch(iy)	{
		case 0:
			if(itemlist[ix].number != 0)	{
				if(items[itemlist[ix].number - 1].aff == 1)	{
					if((ch = bat_magic_sel1(NULL)) != -1)	{
						bat_item_use(ix, astat, ch);
						item_done = 1;
					}
				}
				else if(items[itemlist[ix].number - 1].aff == 6)	{
					if((ch = bat_magic_sel2(NULL)) != -1)	{
						bat_item_use(ix, astat, ch);
						item_done = 1;
					}
				}
			}
			break;
	}
}

static void bat_magic_sel(stat_data_t * astat)	{
	int ch;
	switch(my)	{
		case 0:
			if(astat->magic.mag_lev1[mx] != 0)	{
				if(magics[(astat->magic.mag_lev1[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev1[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev1[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev1[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 1:
			if(astat->magic.mag_lev2[mx] != 0)	{
				if(magics[(astat->magic.mag_lev2[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev2[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev2[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev2[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 2:
			if(astat->magic.mag_lev3[mx] != 0)	{
				if(magics[(astat->magic.mag_lev3[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev3[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev3[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev3[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 3:
			if(astat->magic.mag_lev4[mx] != 0)	{
				if(magics[(astat->magic.mag_lev4[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev4[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev4[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev4[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 4:
			if(astat->magic.mag_lev5[mx] != 0)	{
				if(magics[(astat->magic.mag_lev5[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev5[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev5[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev5[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 5:
			if(astat->magic.mag_lev6[mx] != 0)	{
				if(magics[(astat->magic.mag_lev6[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev6[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev6[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev6[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 6:
			if(astat->magic.mag_lev7[mx] != 0)	{
				if(magics[(astat->magic.mag_lev7[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev7[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev7[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev7[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 7:
			if(astat->magic.mag_lev8[mx] != 0)	{
				if(magics[(astat->magic.mag_lev1[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev8[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev8[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev8[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 8:
			if(astat->magic.mag_lev9[mx] != 0)	{
				if(magics[(astat->magic.mag_lev9[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev9[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev9[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev9[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		case 9:
			if(astat->magic.mag_lev10[mx] != 0)	{
				if(magics[(astat->magic.mag_lev10[mx] - 1)].typ < 64)	{
					if((ch = bat_magic_sel1(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev10[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
				else if(magics[(astat->magic.mag_lev10[mx] - 1)].typ >= 64)	{
					if((ch = bat_magic_sel2(astat)) > -1)	{
						bat_magic_use(astat->magic.mag_lev10[mx] - 1, astat, ch);
						magic_done = 1;
					}
				}
			}
			break;
		default:
			break;
	}
}

static int bat_skill_sel1(stat_data_t * astat)	{
	int y = 69;
	int x = 33;
	cont_state_t * state;
	uint64 time_since = timer_ms_gettime64();

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));
		if(state != NULL)	{
			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				y -= 74;
				if(y < 69)	{
					y = 217;
					x -= 79;
					if(x < 33)
						x = 191;
				}
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				y += 74;
				if(y > 217)	{
					y = 69;
					x += 79;
					if(x > 191)
						x = 33;
				}
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
				return -1;
			}
			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
				if(enemies[((((x - 33) / 79) * 3) + (y - 69) / 74)].stats.hp_rem != 0)
					return ((((x - 33) / 79) * 3) + (y - 69) / 74);
			}
		}
		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);

		bat_draw_names();
		bat_draw_hp();
		bat_draw_mp();
		bat_draw_ul();
		bat_draw_vert();
		bat_draw_ll();
		bat_draw_horiz();
		bat_draw_lr();
		bat_draw_ur();
		bat_draw_enemies();
		bat_draw_menu();
		bat_draw_options();
		bat_draw_skillname(astat);
		if(sn < 5)	{
			ljsdcdev_arrow(184, 340 + (sn * 24), 184, 320 + (sn * 24), 200, 330 + (sn * 24), 255, 255, 255, 255);
		}
		else	{
			ljsdcdev_arrow(184, 340 + ((sn - 5) * 24), 184, 320 + ((sn - 5) * 24), 200, 330 + ((sn - 5) * 24), 255, 255, 255, 255);
		}
		ljsdcdev_arrow(x, y + 16, x, y, x + 16, y + 8, 255, 255, 255, 255);
		bat_draw_player();
		plx_scene_end();
	}
}

static void bat_skill_sel(stat_data_t * astat)	{
	int ch;
	uint16 * pt1;
	uint8 * pt2;
	if(st == 0)	{
		pt1 = astat->skills.sk_type1;
		pt2 = astat->skills.sk_t1_chl;
	}
	else if(st == 1)	{
		pt1 = astat->skills.sk_type2;
		pt2 = astat->skills.sk_t2_chl;
	}
	else if(st == 2)	{
		pt1 = astat->skills.sk_type3;
		pt2 = astat->skills.sk_t3_chl;
	}
	else if(st == 3)	{
		pt1 = astat->skills.sk_type4;
		pt2 = astat->skills.sk_t4_chl;
	}
	else	{
		pt1 = astat->skills.sk_type5;
		pt2 = astat->skills.sk_t5_chl;
	}

	if(pt1[sn] > 0 && pt2[sn] > 0)	{
		if(skills[pt1[sn] - 1].aff == 6)	{
			if((ch = bat_skill_sel1(astat)) > -1)	{
				bat_skill_use(pt1[sn] - 1, astat, ch);
				skill_done = 1;
			}
		}
	}
}

static void bat_do_menu(stat_data_t * astat)	{
	cont_state_t * state;
	uint64 time_since = timer_ms_gettime64();
	sel = 0;
	sel1 = 0;
	int done = 0;
	int en_sp;
	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(done == 4)	{
				if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
					my++;
					if(my > 9)
						my = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
					my--;
					if(my < 0)
						my = 9;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_RIGHT && time_since + 200 < timer_ms_gettime64())	{
					mx++;
					if(mx > 3)
						mx = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_LEFT && time_since + 200 < timer_ms_gettime64())	{
					mx--;
					if(mx < 0)
						mx = 3;
					time_since = timer_ms_gettime64();
				}
			}
			else if(done == 5)	{
				if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
					iy++;
					if(iy > 19)
						iy = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
					iy--;
					if(iy < 0)
						iy = 19;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_RIGHT && time_since + 200 < timer_ms_gettime64())	{
					ix++;
					if(ix > 1)
						ix = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_LEFT && time_since + 200 < timer_ms_gettime64())	{
					ix--;
					if(ix < 0)
						ix = 1;
					time_since = timer_ms_gettime64();
				}
			}
			else if(done == 6)	{
				if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
					st++;
					if(st > 4)
						st = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
					st--;
					if(st < 0)
						st = 4;
					time_since = timer_ms_gettime64();
				}
			}
			else if(done == 7)	{
				if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
					sn++;
					if(sn > 9)
						sn = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
					sn--;
					if(sn < 0)
						sn = 9;
					time_since = timer_ms_gettime64();
				}
			}
			else	{
				if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
					sel1++;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
					sel1--;
					time_since = timer_ms_gettime64();
				}
			}
			if (state->buttons & CONT_A && done == 1 && time_since + 200 < timer_ms_gettime64())	{
				if(enemies[en_menu[sel]].stats.hp_rem != 0 && en_menu[sel] != -1)	{
					bat_att_damage(astat, &enemies[en_menu[sel]]);
					break;
				}
				time_since = timer_ms_gettime64();
			}

			if(state->buttons & CONT_A && done == 0 && time_since + 200 < timer_ms_gettime64())	{
				if(sel1 == 0)	{
					done = 1;
					col = 200.0f;
					if(astat->battle.defend == 1)
						astat->battle.defend = 0;

				}
				else if(sel1 == 1) {
					done = 4;
				}
				else if(sel1 == 2)	{
					done = 6;
				}
				else if(sel1 == 3)	{
					done = 5;
				}
				else if(sel1 == 4)	{
					done = 3;
					time1 = time(NULL);
					while(time1 + 2 > time(NULL))
						bat_defend(astat);
					astat->battle.defend = 1;
					break;
				}
				if(sel1 == 5)	{
					en_sp = ljsdcdev_random(0, 8);
					while(enemies[en_sp].stats.speed == 0 || enemies[en_sp].stats.hp_rem == 0)
						en_sp = ljsdcdev_random(0, 8);
					time1 = time(NULL);
					while(time1 + 2 > time(NULL))
						bat_run(astat, &enemies[en_sp]);
					break;
				}
				time_since = timer_ms_gettime64();
			}

			if(done == 0)	{
				if(sel1 > 5)
					sel1 = 0;

				if(sel1 < 0)
					sel1 = 5;

				sel = sel1;
				col = 32.0f;
			}

			if(done == 1)	{
				if(col == 200.0f)
					sel = sel1;

				if(col == 334.0f)
					sel = sel1 + 5;

				if(sel1 > 4 && col == 200.0f)	{
					sel1 = 0;
					col = 334.0f;
				}
				if(sel1 < 0 && col == 200.0f)	{
					sel1 = 3;
					col = 334.0f;
				}
				if(sel1 < 0 && col == 334.0f)	{
					sel1 = 4;
					col = 200.0f;
				}
				if(sel1 > 3 && col == 334.0f)	{
					sel1 = 0;
					col = 200.0f;
				}

				if(state->buttons & CONT_DPAD_LEFT && time_since + 200 < timer_ms_gettime64())	{
					if(col == 200.0f && sel1 < 4)
						col = 334.0f;
					else
						col = 200.0f;
					time_since = timer_ms_gettime64();
				}

				if(state->buttons & CONT_DPAD_RIGHT && time_since + 200 < timer_ms_gettime64())	{
					if(col == 200.0f && sel1 < 4)
						col = 334.0f;
					else
						col = 200.0f;
					time_since = timer_ms_gettime64();
				}

				if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
					sel = 0;
					sel1 = 0;
					col = 32.0f;
					done = 0;
					time_since = timer_ms_gettime64();
				}
			}

			if(done == 4)	{
				if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
					sel = 0;
					sel1 = 0;
					col = 32.0f;
					done = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
					bat_magic_sel(astat);
					if(magic_done == 1)	{
						magic_done = 0;
						break;
					}
				}
			}
			if(done == 5)	{
				if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
					sel = 0;
					sel1 = 0;
					col = 32.0f;
					done = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
					bat_item_sel(astat);
					if(item_done == 1)	{
						item_done = 0;
						break;
					}
				}
			}
			if(done == 6)	{
				if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
					sel = 0;
					sel1 = 0;
					col = 32.0f;
					done = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
					done = 7;
					time_since = timer_ms_gettime64();
				}
			}
			if(done == 7)	{
				if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
					done = 6;
					st = 0;
					time_since = timer_ms_gettime64();
				}
				if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
					bat_skill_sel(astat);
					if(skill_done == 1)	{
						skill_done = 0;
						break;
					}
				}
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);

		bat_draw_names();
		bat_draw_hp();
		bat_draw_mp();
		bat_draw_ul();
		bat_draw_vert();
		bat_draw_ll();
		bat_draw_horiz();
		bat_draw_lr();
		bat_draw_ur();
		bat_draw_enemies();
		bat_draw_indic(astat);
		ljsdcdev_line_tr(16, 320, 32, 304, 255, 255, 255, 255);
		ljsdcdev_line_tr(184, 320, 200, 304, 255, 255, 255, 255);
		ljsdcdev_line_tr(32, 468, 16, 452, 255, 255, 255, 255);
		ljsdcdev_line_tr(200, 468, 184, 452, 255, 255, 255, 255);
		ljsdcdev_line_tr(168, 320, 152, 304, 255, 255, 255, 255);
		ljsdcdev_line_tr(496, 320, 480, 304, 255, 255, 255, 255);
		ljsdcdev_line_tr(152, 468, 168, 452, 255, 255, 255, 255);
		ljsdcdev_line_tr(480, 468, 496, 452, 255, 255, 255, 255);
		ljsdcdev_vline_tr(16, 320, 452, 255, 255, 255, 255);
		ljsdcdev_vline_tr(168, 320, 452, 255, 255, 255, 255);
		ljsdcdev_vline_tr(184, 320, 452, 255, 255, 255, 255);
		ljsdcdev_vline_tr(496, 320, 452, 255, 255, 255, 255);
		ljsdcdev_hline_tr(32, 152, 304, 255, 255, 255, 255);
		ljsdcdev_hline_tr(32, 152, 468, 255, 255, 255, 255);
		ljsdcdev_hline_tr(200, 480, 304, 255, 255, 255, 255);
		ljsdcdev_hline_tr(200, 480, 468, 255, 255, 255, 255);

		ljsdcdev_arrow(col, 340 + (sel1 * 20), col, 320 + (sel1 * 20), col + 16, 330 + (sel1 * 20), 255, 255, 255, 255);
		bat_draw_options();
		if(done == 4)	{
			if(my < 5)	{
				bat_draw_mname(astat);
				ljsdcdev_arrow(mx * 74 + 184, 340 + (my * 24), mx * 74 + 184, 320 + (my * 24), mx * 74 + 200, 330 + (my * 24), 255, 255, 255, 255);
			}

			else	{
				bat_draw_mname2(astat);
				ljsdcdev_arrow(mx * 74 + 184, 340 + ((my - 5) * 24), mx * 74 + 184, 320 + ((my - 5) * 24), mx * 74 + 200, 330 + ((my - 5) * 24), 255, 255, 255, 255);
			}
		}

		else if(done == 5)	{
			if(iy < 5)	{
				bat_draw_itname();
				ljsdcdev_arrow(ix * 148 + 184, 340 + (iy * 24), ix * 148 + 184, 320 + (iy * 24), ix * 148 + 200, 330 + (iy * 24), 255, 255, 255, 255);
			}

			else if(iy < 10)	{
				bat_draw_itname2();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 5) * 24), ix * 148 + 184, 320 + ((iy - 5) * 24), ix * 148 + 200, 330 + ((iy - 5) * 24), 255, 255, 255, 255);
			}

			else if(iy < 15)	{
				bat_draw_itname3();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 10) * 24), ix * 148 + 184, 320 + ((iy - 10) * 24), ix * 148 + 200, 330 + ((iy - 10) * 24), 255, 255, 255, 255);
			}

			else	{
				bat_draw_itname4();
				ljsdcdev_arrow(ix * 148 + 184, 340 + ((iy - 15) * 24), ix * 148 + 184, 320 + ((iy - 15) * 24), ix * 148 + 200, 330 + ((iy - 15) * 24), 255, 255, 255, 255);
			}
		}

		else if(done == 6)	{
			ljsdcdev_text(fcxt_ax, "Offensive", 204, 340, 255, 255, 255, 255);
			ljsdcdev_text(fcxt_ax, "Defensive", 204, 364, 255, 255, 255, 255);
			ljsdcdev_text(fcxt_ax, "Special 1", 204, 388, 255, 255, 255, 255);
			ljsdcdev_text(fcxt_ax, "Special 2", 204, 412, 255, 255, 255, 255);
			ljsdcdev_text(fcxt_ax, "Special 3", 204, 436, 255, 255, 255, 255);
			ljsdcdev_arrow(184, 340 + (st * 24), 184, 320 + (st * 24), 200, 330 + (st * 24), 255, 255, 255, 255);
		}

		else if(done == 7)	{
			if(sn < 5)	{
				ljsdcdev_arrow(184, 340 + (sn * 24), 184, 320 + (sn * 24), 200, 330 + (sn * 24), 255, 255, 255, 255);
			}
			else	{
				ljsdcdev_arrow(184, 340 + ((sn - 5) * 24), 184, 320 + ((sn - 5) * 24), 200, 330 + ((sn - 5) * 24), 255, 255, 255, 255);
			}
			bat_draw_skillname(astat);
		}

		else
			bat_draw_enemyn();

		bat_draw_player();
		plx_scene_end();
	}
}

static void bat_order()	{
	unsigned int i = 50;
	unsigned int l = 0;
	while(i > 0)	{
		if(i == stats[0].stats.speed)	{
			p[l] = &stats[0];
			l++;
		}
		if(i == stats[1].stats.speed)	{
			p[l] = &stats[1];
			l++;
		}
		if(i == stats[2].stats.speed)	{
			p[l] = &stats[2];
			l++;
		}
		if(i == stats[3].stats.speed)	{
			p[l] = &stats[3];
			l++;
		}
		if(i == enemies[0].stats.speed)	{
			p[l] = &enemies[0];
			l++;
		}
		if(i == enemies[1].stats.speed)	{
			p[l] = &enemies[1];
			l++;
		}
		if(i == enemies[2].stats.speed)	{
			p[l] = &enemies[2];
			l++;
		}
		if(i == enemies[3].stats.speed)	{
			p[l] = &enemies[3];
			l++;
		}
		if(i == enemies[4].stats.speed)	{
			p[l] = &enemies[4];
			l++;
		}
		if(i == enemies[5].stats.speed)	{
			p[l] = &enemies[5];
			l++;
		}
		if(i == enemies[6].stats.speed)	{
			p[l] = &enemies[6];
			l++;
		}
		if(i == enemies[7].stats.speed)	{
			p[l] = &enemies[7];
			l++;
		}
		if(i == enemies[8].stats.speed)	{
			p[l] = &enemies[8];
			l++;
		}
		i--;
	}

}

static void bat_show_exp()	{
	char string[50];
	char string2[50];
	sprintf(string, "Gained %d experience!", exper);
	sprintf(string2, "Gained %d gold!", goldplus);
	time1 = time(NULL);
	while(time1 + 2 > time(NULL))	{
		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);
		bat_draw_names();
		bat_draw_hp();
		bat_draw_mp();
		bat_draw_ul();
		bat_draw_vert();
		bat_draw_ll();
		bat_draw_horiz();
		bat_draw_lr();
		bat_draw_ur();
		bat_draw_player();
		bat_message(32, 320, 136, "Victory!");
		bat_message(32, 384, 224, string);
		bat_message(288, 384, 192, string2);
		plx_scene_end();
	}
}

static void bat_do_bat()	{
	unsigned int l, j, k = 0;
	char string[40];
	for(l = 0; l <= 12; l++)	{
		if(enemies[0].stats.hp_rem == 0 && enemies[1].stats.hp_rem == 0 &&
		   enemies[2].stats.hp_rem == 0 && enemies[3].stats.hp_rem == 0 &&
		   enemies[4].stats.hp_rem == 0 && enemies[5].stats.hp_rem == 0 &&
		   enemies[6].stats.hp_rem == 0 && enemies[7].stats.hp_rem == 0 &&
		   enemies[8].stats.hp_rem == 0)	{
		   	for(j = 0; j < 4; j++)	{
				if(stats[j].stats.hp_rem > 0)
					k++;
			}
			exper /= k;

			for(j = 0; j < 4; j++)	{
				if(stats[j].stats.hp_rem > 0)
					stats[j].stats.exp += exper;
			}
			bat_show_exp();
			gold += goldplus;
			for(j = 0; j < 4; j++)	{
				if(stats[j].stats.exp >= (25 * pow(stats[j].stats.level, 2)))	{
					lev_level_up(&stats[j]);
					sprintf(string, "%s Leveled Up!", stats[j].name);
					time1 = time(NULL);
					while(time1 + 2 > time(NULL))	{
						plx_scene_begin();
						plx_list_begin(PLX_LIST_OP_POLY);
						plx_list_begin(PLX_LIST_TR_POLY);
						bat_draw_names();
						bat_draw_hp();
						bat_draw_mp();
						bat_draw_ul();
						bat_draw_vert();
						bat_draw_ll();
						bat_draw_horiz();
						bat_draw_lr();
						bat_draw_ur();
						bat_draw_player();
						bat_message(32, 320, 256, string);
						plx_scene_end();
						}
					}
				}
			break;
		}

		if(bat_done == 1)	{
			break;
		}
		if(p[l]->name == 0)	{
			break;
		}
		if(p[l]->ally == 1 && p[l]->stats.hp_rem != 0)	{
			bat_do_menu(p[l]);
		}
		else if(p[l]->ally == -1)	{
			bat_enemy_ai(p[l]);
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);

		bat_draw_names();
		bat_draw_hp();
		bat_draw_mp();
		bat_draw_ul();
		bat_draw_vert();
		bat_draw_ll();
		bat_draw_horiz();
		bat_draw_lr();
		bat_draw_ur();
		bat_draw_enemies();
		bat_draw_player();
		plx_scene_end();
	}
}

int do_battle()	{
	bat_order();
	bat_done = 0;

	while(1)	{
		if(enemies[0].stats.hp_rem == 0 && enemies[1].stats.hp_rem == 0 &&
		   enemies[2].stats.hp_rem == 0 && enemies[3].stats.hp_rem == 0 &&
		   enemies[4].stats.hp_rem == 0 && enemies[5].stats.hp_rem == 0 &&
		   enemies[6].stats.hp_rem == 0 && enemies[7].stats.hp_rem == 0 &&
		   enemies[8].stats.hp_rem == 0)
		   	break;

		if(bat_done == 1)
			break;

		bat_do_bat();
	}

	return 0;
}

