/*	credits.c -- ljsdcdev
	Credits screen
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

static int credits_count_lines(credit_t * credit)	{
	int count = 0;
	int i;

	for(i = 0; i < strlen(credit->message); i++)	{
		if(credit->message[i] == '\n')
			count++;
	}
	return count + 1;
}

void credits_draw_screen()	{
	int i;
	time_t time_since;
	plx_texture_t * txr;

	for(i = 0; i < credits_count; i++)	{
		txr = plx_txr_load(credits[i].imagefn, 0, PVR_TXRLOAD_16BPP);
		time_since = time(NULL) + credits_count_lines(&credits[i]) + 1;
		while(time_since > time(NULL))	{
			plx_scene_begin();
			plx_list_begin(PLX_LIST_OP_POLY);
			plx_txr_send_hdr(txr, PVR_LIST_OP_POLY, 0);
			plx_spr_fnd(&dr_state, 640.0f, 480.0f, 320.0f, 240.0f, 5.0f, 1.0f, 1, 1, 1);
			plx_list_begin(PLX_LIST_TR_POLY);
			plx_fcxt_begin(fcxt_ax);
			plx_fcxt_setsize(fcxt_ax, 32.0f);
			plx_fcxt_setpos(fcxt_ax, 64.0f, 96.0f, 5.0f);
			plx_fcxt_draw(fcxt_ax, credits[i].section);
			plx_fcxt_setsize(fcxt_ax, 16.0f);
			plx_fcxt_setpos(fcxt_ax, 96.0f, 304.0f - (8 * credits_count_lines(&credits[i])), 5.0f);
			plx_fcxt_draw(fcxt_ax, credits[i].message);
			plx_fcxt_end(fcxt_ax);
			plx_scene_end();
		}
		plx_txr_destroy(txr);
	}
}
