 /*	data.h -- ljsdcdev
	General purpose data structures
	ljsdcdev
	Copyright (C) 2002, 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __DATA_H
#define __DATA_H

#include <kos.h>
#include <plx/texture.h>

typedef struct {
	char * name;
	uint8 lev;
	uint8 typ;
	uint8 aff;
	uint8 stat;
	uint8 str;
	uint16 cost;
} mag_desc_t;

typedef struct	{
	char * name;
	uint8 str;
	uint8 typ;
	uint8 eff;
	uint8 aff;
	uint16 sxp_req;
	uint16 * req;
	uint8 req_count;
} skill_desc_t;

typedef struct	{
	char * name;
	uint8 str;
	uint8 typ;
	uint8 eff;
	uint8 aff;
	uint16 cost;
} item_desc_t;

typedef struct	{
	char * name;
	uint16 str_req;
	uint8 att;
	uint8 def;
	uint8 spd;
	uint8 intl;
	uint8 acc;
	uint8 where;
	uint16 cost;
} equip_desc_t;

typedef struct	{
	char name[9];
	uint16 attack;
	uint16 defense;
	uint16 speed;
	uint16 mdef;
	uint16 matt;
	uint8 accuracy;
	uint16 hp;
	uint16 mp;
	uint16 magics[4];
	uint8 element;
	uint16 exp;
	uint16 gold;
	uint16 sxp;
	char fn[20];
} en_desc_t;

typedef struct	{
	char name[9];
	unsigned int attack;
	unsigned int defense;
	unsigned int speed;
	unsigned int strength;
	unsigned int mdef;
	unsigned int matt;
	unsigned int intel;
	unsigned int accuracy;
	unsigned int hp;
	unsigned int mp;
	unsigned int exp;
	unsigned int magics[4][3];
	//unsigned int element;
	char fn[20];
} en_dat_t;

typedef struct {
	char name[9];
	int8 ally;
	struct	{
		uint16 attack;
		uint16 defense;
		uint16 speed;
		uint16 strength;
		uint16 mdef;
		uint16 matt;
		uint16 intel;
		uint16 accuracy;
		uint16 hp;
		uint16 hp_rem;
		uint16 mp;
		uint16 mp_rem;
		uint8 level;
		uint32 exp;
		uint32 sxp;
		uint8 rank;
		uint8 element;
		uint16 gold;
	} stats;
	struct	{
		uint16 mag_lev1[4];
		uint16 mag_lev2[4];
		uint16 mag_lev3[4];
		uint16 mag_lev4[4];
		uint16 mag_lev5[4];
		uint16 mag_lev6[4];
		uint16 mag_lev7[4];
		uint16 mag_lev8[4];
		uint16 mag_lev9[4];
		uint16 mag_lev10[4];
	} magic;
	struct	{
		uint16 sk_type1[10];
		uint8 sk_t1_cht[10];
		uint8 sk_t1_chl[10];
		uint16 sk_type2[10];
		uint8 sk_t2_cht[10];
		uint8 sk_t2_chl[10];
		uint16 sk_type3[10];
		uint8 sk_t3_cht[10];
		uint8 sk_t3_chl[10];
		uint16 sk_type4[10];
		uint8 sk_t4_cht[10];
		uint8 sk_t4_chl[10];
		uint16 sk_type5[10];
		uint8 sk_t5_cht[10];
		uint8 sk_t5_chl[10];
	} skills;
	struct	{
		uint8 equipment[10];
	} equip;
	struct	{
		plx_texture_t * splayer;
	} images;
	struct 	{
		uint8 defend;
	} battle;
	struct	{
		uint32 kills;
		uint32 defeats;
	} bat;
} stat_data_t;

typedef struct	{
	char name[9];
	struct	{
		uint16 attack;
		uint16 defense;
		uint16 speed;
		uint16 strength;
		uint16 mdef;
		uint16 matt;
		uint16 intel;
		uint16 accuracy;
		uint16 hp;
		uint16 hp_rem;
		uint16 mp;
		uint16 mp_rem;
		uint8 level;
		uint32 exp;
		uint16 sxp;
		uint8 rank;
	} stats;
	struct	{
		uint16 mag_lev1[4];
		uint16 mag_lev2[4];
		uint16 mag_lev3[4];
		uint16 mag_lev4[4];
		uint16 mag_lev5[4];
		uint16 mag_lev6[4];
		uint16 mag_lev7[4];
		uint16 mag_lev8[4];
		uint16 mag_lev9[4];
		uint16 mag_lev10[4];
	} magic;
	struct	{
		uint16 sk_type1[10];
		uint8 sk_t1_cht[10];
		uint8 sk_t1_chl[10];
		uint16 sk_type2[10];
		uint8 sk_t2_cht[10];
		uint8 sk_t2_chl[10];
		uint16 sk_type3[10];
		uint8 sk_t3_cht[10];
		uint8 sk_t3_chl[10];
		uint16 sk_type4[10];
		uint8 sk_t4_cht[10];
		uint8 sk_t4_chl[10];
		uint16 sk_type5[10];
		uint8 sk_t5_cht[10];
		uint8 sk_t5_chl[10];
	} skills;
	struct	{
		uint8 equipment[10];
	} equip;
	struct	{
		uint32 kills;
		uint32 defeats;
	} bat;
} stats_data_t;

typedef struct	{
	struct	{
		uint8 r;
		uint8 g;
		uint8 b;
	} mc;
	struct	{
		uint8 r;
		uint8 g;
		uint8 b;
	} tc;
	struct	{
		uint8 r;
		uint8 g;
		uint8 b;
		uint8 mr;
		uint8 mg;
		uint8 mb;
	} bc;
} opt_t;

typedef struct	{
	struct {
		stats_data_t p1;
		stats_data_t p2;
		stats_data_t p3;
		stats_data_t p4;
	} stats;
	struct {
		uint32 x;
		uint32 y;
		uint32 num;
	} map;
	opt_t opts;
	uint8 items[40][2];
	uint8 equip[40];
	time_t time;
	uint32 gold;
	uint8 switches[4096];
} save_data_t;

typedef struct	{
	uint16 x;
	uint16 y;
	uint16 tox;
	uint16 toy;
	uint16 map;
} warp_t;

typedef struct	{
	uint16 x;
	uint16 y;
	uint16 curx;
	uint16 cury;
	uint8 mov;
	uint8 freq;
	plx_texture_t * txr;
	uint8 msg_count;
	int8 msg_num;
	char ** msgs;
	uint64 time_move;
} npc_t;

typedef struct	{
	uint16 type;
	uint16 count;
	uint16 x;
	uint16 y;
	uint16 switch_num;
} treasure_t;

typedef struct	{
	uint8 * items;
	uint8 itemcount;
	char * name;
	int type;
	uint16 x;
	uint16 y;
} shop_t;

typedef struct	{
	char * name;
	uint16 cost;
	uint16 x;
	uint16 y;
} inn_t;

typedef struct	{
	stat_data_t enemy[10];
	warp_t * warps;
	uint16 warp_count;
	npc_t * npcs;
	uint16 npc_count;
	treasure_t * treas;
	uint16 treas_count;
	shop_t * shop;
	uint8 shopcount;
	inn_t * inn;
	uint8 inncount;
	uint32 x1;
	uint32 x2;
	uint32 y1;
	uint32 y2;
	uint8 minen;
	uint8 maxen;
	uint8 freq;
	uint8 minst;
} area_t;

typedef struct	{
	int h;
	int m;
	int s;
} game_time_t;

typedef struct	{
	uint8 number;
	uint8 count;
} item_t;

typedef struct	{
	char * section;
	char * message;
	char * imagefn;
} credit_t;

#endif /* ! __DATA_H */
