/*	inn.c -- ljsdcdev
	Inns
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

static void inn_basic_lines()	{
	ljsdcdev_hline_tr(128, 512, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(128, 512, 96, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 160, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 160, 176, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_vline_tr(112, 48, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(528, 48, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(64, 128, 160, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(176, 128, 160, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(512, 96, 528, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(528, 48, 512, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(112, 48, 128, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(128, 96, 112, 80, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(160, 176, 176, 160, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(64, 128, 80, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(176, 128, 160, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(80, 176, 64, 160, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_vline_tr(64, 384, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(240, 384, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 224, 368, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 224, 432, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(64, 384, 80, 368, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(224, 432, 240, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(80, 432, 64, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(240, 384, 224, 368, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_hline_tr(272, 576, 112, 255, 255, 255, 255);
	ljsdcdev_hline_tr(272, 576, 176, 255, 255, 255, 255);
	ljsdcdev_vline_tr(256, 128, 160, 255, 255, 255, 255);
	ljsdcdev_vline_tr(592, 128, 160, 255, 255, 255, 255);

	ljsdcdev_line_tr(256, 128, 272, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(576, 176, 592, 160, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(272, 176, 256, 160, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(592, 128, 576, 112, 255, options.bc.r, options.bc.g, options.bc.b);
}

static inline void inn_basic_arrow(int num)	{
	ljsdcdev_arrow(80, 16 * num + 144, 80, 16 * num + 128, 96, 16 * num + 136, 255, options.bc.r, options.bc.g, options.bc.b);
}

static inline void inn_draw_title(char * title)	{
	plx_fcxt_setsize(fcxt_ax, 22.0f);
	plx_fcxt_setpos(fcxt_ax, 128.0f, 80.0f, 5.0f);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_draw(fcxt_ax, title);
	plx_fcxt_end(fcxt_ax);
}

static void inn_draw_msg(inn_t * inn)	{
	char msg[200];
	sprintf(msg, "It costs %d gold to stay here.\nWould you like to stay?", inn->cost);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 272.0f, 144.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, msg);
	plx_fcxt_end(fcxt_ax);
}

static void inn_basic_text()	{
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 96.0f, 144.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax,	"Stay\n"
				"Leave\n");
	plx_fcxt_end(fcxt_ax);
}

static void inn_gold()	{
	char txt[50];
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	plx_fcxt_setpos(fcxt_ax, 80.0f, 400.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Gold:");
	plx_fcxt_setpos(fcxt_ax, 80.0f, 416.0f, 5.0f);
	sprintf(txt, "%lu G", gold);
	plx_fcxt_draw(fcxt_ax, txt);
	plx_fcxt_end(fcxt_ax);
}

static void inn_sleep(inn_t * inn)	{
	int i, j;
	for(i = 0; i < 4; i++)	{
		stats[i].stats.hp_rem = stats[i].stats.hp;
		stats[i].stats.mp_rem = stats[i].stats.mp;
		for(j = 0; j < 10; j++)	{
			stats[i].skills.sk_t1_chl[j] = stats[i].skills.sk_t1_cht[j];
			stats[i].skills.sk_t2_chl[j] = stats[i].skills.sk_t2_cht[j];
			stats[i].skills.sk_t3_chl[j] = stats[i].skills.sk_t3_cht[j];
			stats[i].skills.sk_t4_chl[j] = stats[i].skills.sk_t4_cht[j];
			stats[i].skills.sk_t5_chl[j] = stats[i].skills.sk_t5_cht[j];
		}
	}
	gold -= inn->cost;
}

void inn_open(area_t * cur_area, uint8 inn_num)	{
	cont_state_t * state;
	int sel = 0;
	uint64 time_since = timer_ms_gettime64();
	inn_t * inn = &cur_area->inn[inn_num];

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
				if(sel == 0)	{
					if(gold >= inn->cost)	{
						inn_sleep(inn);
						break;
					}
				}
				else	{
					break;
				}
				time_since = timer_ms_gettime64();
			}

			if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
				break;
			}
			
			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				if(sel != 1)	{
					sel++;
				}
				else	{
					sel = 0;
				}
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				if(sel != 0)	{
					sel--;
				}
				else	{
					sel = 1;
				}
				time_since = timer_ms_gettime64();
			}
			
		}
		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		
		inn_basic_lines();
		inn_basic_arrow(sel);
		
		plx_list_begin(PLX_LIST_TR_POLY);

		inn_basic_text();
		inn_draw_msg(inn);
		inn_gold();
		inn_draw_title(inn->name);
		plx_scene_end();
	}
}
