/*	ljm.h -- ljsdcdev
	.ljm stuff
	ljsdcdev
	Copright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <kos.h>
#include <plx/dr.h>
#include <plx/sprite.h>
#include <plx/list.h>

typedef struct	{
	uint32 user1;
	uint16 user2, user3;
	uint8 user4, user5, user6;
} tile_dat_t;

typedef struct	{
	uint8 dim;
	uint32 xblocks;
	uint32 yblocks;
	uint32 tilecount;
	uint32 version;
} ljm_info_t;

typedef struct	{
	uint32 evx, evy;
	uint8 evtype;
	uint32 evd1, evd2, evd3;
} ljm_event_t;

typedef struct	{
	uint32 count;
	uint32 * seq;
	uint8 delay;
	uint64 sttime;
	uint32 current;
} ljm_anim_t;

plx_texture_t ** tiles_txr;
uint32 ** tile_map;
uint8 dim;
uint32 map_x;
uint32 map_y;
uint32 xoffset, yoffset;
uint32 tilecount;
uint32 version;
uint32 eventcount;
uint32 animcount;
tile_dat_t * tiles;
ljm_event_t * event;
ljm_anim_t * anim;

/* Functions*/
int ljm_load(const char * fn, int magnify);
int ljm_free();
tile_dat_t * ljm_get_data(uint32 x, uint32 y);
tile_dat_t * ljm_get_blk(uint32 blknum);
tile_dat_t * ljm_get_data_pixels(uint32 x, uint32 y);
void ljm_set_xoffset(uint32 xoff);
void ljm_set_yoffset(uint32 yoff);
void ljm_map_scroll(uint32 xpos, uint32 ypos);
ljm_info_t ljm_map_info();
void ljm_draw_bg(plx_dr_state_t * state);
void ljm_inc_anims();
ljm_event_t * ljm_scan_events(uint32 x, uint32 y);
ljm_event_t * ljm_scan_events_type(uint32 x, uint32 y, uint8 type);
