/*	ljsdcdev.h -- ljsdcdev
	Main includes, prototypes, defines, etc.
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef __LJSDCDEV_H
#define __LJSDCDEV_H

#include <kos.h>
#include <png/png.h>
#include <zlib/zlib.h>
#include <plx/dr.h>
#include <plx/sprite.h>
#include <plx/font.h>
#include <plx/list.h>
#include <plx/color.h>
#include <expat/expat.h>
#include <math.h>
#include <stdlib.h>

#include "data.h"

plx_dr_state_t dr_state;
plx_fcxt_t * fcxt_ax;
plx_font_t * font_ax;
stat_data_t stats[4];
stat_data_t enemies[9];
opt_t options;
uint32 posx, posy;
int mapnum;
mag_desc_t * magics;
skill_desc_t * skills;
item_desc_t * items;
equip_desc_t * equipment;
en_desc_t * en_desc;
credit_t * credits;
item_t itemlist[40];
uint8 equiplist[40];
uint8 switches[4096];
uint32 gold;
time_t gtime;
time_t sttime;
uint16 skill_count;
uint16 credits_count;

int do_battle();
void do_tilemap();
void tilemap_mainloop();
void tilemap_init(uint32 x, uint32 y);
void menu_do_menu();
int vmu_select(save_data_t * save, int mode);
void save_game();
int load_game();
void lev_level_up(stat_data_t * stats);
void name_set(int pl);
void msg_box_plain(const char * text, uint8 r, uint8 g, uint8 b);
void shop_open(area_t * area, uint8 shopnum);
void inn_open(area_t * area, uint8 inn_num);

/*	libljsdcdev.c stuff -- this will eventually be split out into its own header for libljsdcdev,
	but there isn't enough there yet!	*/

int ljsdcdev_random(int min, int max);
void ljsdcdev_line_tr(float x1, float y1, float x2, float y2, uint8 a, uint8 r, uint8 g, uint8 b);
void ljsdcdev_hline_tr(float x1, float x2, float y, uint8 a, uint8 r, uint8 g, uint8 b);
void ljsdcdev_vline_tr(float x, float y1, float y2, uint8 a, uint8 r, uint8 g, uint8 b);
void ljsdcdev_arrow(float x1, float y1, float x2, float y2, float x3, float y3, uint8 a, uint8 r, uint8 g, uint8 b);
void ljsdcdev_text(plx_fcxt_t * fcxt, const char * msg, float x, float y, uint8 a, uint8 r, uint8 g, uint8 b);

/* misc.c */
unsigned long misc_get_filesize(FILE * file);
int misc_add_equip(int number);
int misc_add_item(int number, int count);
void misc_start_timer();
void misc_update_timer();
game_time_t misc_get_timer();
void misc_stats_setup();
int misc_get_itcount();
int misc_get_eqcount();
void misc_sort_equip();
void misc_sort_items();
int misc_check_skilldep(int ch, int type, int i);
int misc_add_skill(int num, int ch, int type);
char ** misc_get_mlevtxt(int ch, int lev);

int xml_parse_type(int type);
void credits_draw_screen();

#endif
