/*	menu.c -- ljsdcdev
	In-game menu
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

static void menu_draw_ul()	{
	ljsdcdev_line_tr(32, 48, 48, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(32, 320, 48, 304, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(208, 48, 224, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(208, 272, 224, 256, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(416, 48, 432, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(416, 272, 432, 256, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_draw_ll()	{
	ljsdcdev_line_tr(48, 264, 32, 248, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(48, 448, 32, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(224, 224, 208, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(224, 448, 208, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(432, 224, 416, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(432, 448, 416, 432, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_draw_ur()	{
	ljsdcdev_line_tr(192, 48, 176, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(192, 320, 176, 304, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(400, 48, 384, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(400, 272, 384, 256, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(608, 48, 592, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(608, 272, 592, 256, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_draw_lr()	{
	ljsdcdev_line_tr(176, 264, 192, 248, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(176, 448, 192, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(384, 224, 400, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(384, 448, 400, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(592, 224, 608, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(592, 448, 608, 432, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_draw_hl()	{
	ljsdcdev_hline_tr(48, 176, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 176, 264, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 176, 304, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 176, 448, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(224, 384, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(224, 384, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(224, 384, 256, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(224, 384, 448, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(432, 592, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(432, 592, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(432, 592, 256, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(432, 592, 448, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_draw_vl()	{
	ljsdcdev_vline_tr(32, 48, 248, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(192, 48, 248, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(32, 320, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(192, 320, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(208, 48, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(400, 48, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(208, 272, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(400, 272, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(416, 48, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(608, 48, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(416, 272, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(608, 272, 432, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_draw_txt()	{
	plx_fcxt_setsize(fcxt_ax, 24.0f);
	plx_fcxt_setpos(fcxt_ax, 64.0f, 82.0f, 5.0f);
	plx_fcxt_setcolor4f(fcxt_ax, 1.0f, 1.0f, 1.0f, 1.0f);
	plx_fcxt_draw(fcxt_ax, "Items\n"
					"Equip\n"
					"Magic\n"
					"Skills\n"
					"Stats\n"
					"Save\n"
					"Quit\n");
}

static void menu_draw_names()	{
	plx_fcxt_setsize(fcxt_ax, 18.0f);
	plx_fcxt_setpos(fcxt_ax, 224.0f, 112.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, stats[0].name);
	plx_fcxt_setpos(fcxt_ax, 432.0f, 112.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, stats[1].name);
	plx_fcxt_setpos(fcxt_ax, 224.0f, 336.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, stats[2].name);
	plx_fcxt_setpos(fcxt_ax, 432.0f, 336.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, stats[3].name);
}

static void menu_draw_hp()	{
	char  hpc[14];
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	sprintf(hpc, "HP: %d/%d", stats[0].stats.hp_rem, stats[0].stats.hp);
	plx_fcxt_setpos(fcxt_ax, 224.0f, 176.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, hpc);
	sprintf(hpc, "HP: %d/%d", stats[1].stats.hp_rem, stats[1].stats.hp);
	plx_fcxt_setpos(fcxt_ax, 432.0f, 176.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, hpc);
	sprintf(hpc, "HP: %d/%d", stats[2].stats.hp_rem, stats[2].stats.hp);
	plx_fcxt_setpos(fcxt_ax, 224.0f, 400.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, hpc);
	sprintf(hpc, "HP: %d/%d", stats[3].stats.hp_rem, stats[3].stats.hp);
	plx_fcxt_setpos(fcxt_ax, 432.0f, 400.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, hpc);
}

static void menu_draw_mp()	{
	char  mpc[14];
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	sprintf(mpc, "MP: %d/%d", stats[0].stats.mp_rem, stats[0].stats.mp);
	plx_fcxt_setpos(fcxt_ax, 224.0f, 192.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, mpc);
	sprintf(mpc, "MP: %d/%d", stats[1].stats.mp_rem, stats[1].stats.mp);
	plx_fcxt_setpos(fcxt_ax, 432.0f, 192.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, mpc);
	sprintf(mpc, "MP: %d/%d", stats[2].stats.mp_rem, stats[2].stats.mp);
	plx_fcxt_setpos(fcxt_ax, 224.0f, 416.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, mpc);
	sprintf(mpc, "MP: %d/%d", stats[3].stats.mp_rem, stats[3].stats.mp);
	plx_fcxt_setpos(fcxt_ax, 432.0f, 416.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, mpc);
}

static void menu_draw_class()	{
	char cl[16];
	int i;
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	for(i = 0; i < 4; i++)	{
		if(stats[i].stats.rank == 0)	{
			strcpy(cl, "Fighter");
		}
		else if(stats[i].stats.rank == 1)	{
			strcpy(cl, "Thief");
		}
		else if(stats[i].stats.rank == 2)	{
			strcpy(cl, "Black Mage");
		}
		else if(stats[i].stats.rank == 3)	{
			strcpy(cl, "White Mage");
		}

		if(i == 0)	{
			plx_fcxt_setpos(fcxt_ax, 224.0f, 128.0f, 5.0f);
			plx_fcxt_draw(fcxt_ax, cl);
		}
		else if(i == 1)	{
			plx_fcxt_setpos(fcxt_ax, 432.0f, 128.0f, 5.0f);
			plx_fcxt_draw(fcxt_ax, cl);
		}
		else if(i == 2)	{
			plx_fcxt_setpos(fcxt_ax, 224.0f, 352.0f, 5.0f);
			plx_fcxt_draw(fcxt_ax, cl);
		}
		else if(i == 3)	{
			plx_fcxt_setpos(fcxt_ax, 432.0f, 352.0f, 5.0f);
			plx_fcxt_draw(fcxt_ax, cl);
		}
	}
}

static void menu_draw_lvl()	{
	char string[20];
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	sprintf(string, "Level %d", stats[0].stats.level);
	plx_fcxt_setpos(fcxt_ax, 224.0f, 160.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, string);
	sprintf(string, "Level %d", stats[1].stats.level);
	plx_fcxt_setpos(fcxt_ax, 432.0f, 160.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, string);
	sprintf(string, "Level %d", stats[2].stats.level);
	plx_fcxt_setpos(fcxt_ax, 224.0f, 384.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, string);
	sprintf(string, "Level %d", stats[3].stats.level);
	plx_fcxt_setpos(fcxt_ax, 432.0f, 384.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, string);
}

static void menu_draw_img()	{
	plx_txr_send_hdr(stats[0].images.splayer, PLX_LIST_TR_POLY, 0);
	plx_spr_fnd(&dr_state, 32, 32, 240, 64, 1.0f, 1.0f, 1, 1, 1);
	plx_txr_send_hdr(stats[1].images.splayer, PLX_LIST_TR_POLY, 0);
	plx_spr_fnd(&dr_state, 32, 32, 448, 64, 1.0f, 1.0f, 1, 1, 1);
	plx_txr_send_hdr(stats[2].images.splayer, PLX_LIST_TR_POLY, 0);
	plx_spr_fnd(&dr_state, 32, 32, 240, 286, 1.0f, 1.0f, 1, 1, 1);
	plx_txr_send_hdr(stats[3].images.splayer, PLX_LIST_TR_POLY, 0);
	plx_spr_fnd(&dr_state, 32, 32, 448, 286, 1.0f, 1.0f, 1, 1, 1);
}

static void menu_draw_goldtime()	{
	char txt[50];
	game_time_t now = misc_get_timer();

	plx_fcxt_setpos(fcxt_ax, 64.0f, 336.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Gold:\n");
	sprintf(txt, "%lu G\n\n", gold);
	plx_fcxt_draw(fcxt_ax, txt);

	plx_fcxt_draw(fcxt_ax, "Time:\n");
	sprintf(txt, "%d:%02d:%02d", now.h, now.m, now.s);
	plx_fcxt_draw(fcxt_ax, txt);
}

static void menu_draw_arrow(int sel)	{
	int point = 58 + (sel * 24);
	ljsdcdev_arrow(40, point + 24, 40, point, 56, point + 12, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_skill_lines()	{
	ljsdcdev_hline_tr(48, 176, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 176, 96, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 176, 128, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 176, 240, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 176, 368, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 176, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(32, 48, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(192, 48, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(32, 144, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(192, 144, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(32, 384, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(192, 384, 416, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(32, 48, 48, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(32, 144, 48, 128, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(176, 96, 192, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(176, 240, 192, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(48, 96, 32, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(48, 240, 32, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(192, 48, 176, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(192, 144, 176, 128, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(32, 384, 48, 368, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(176, 432, 192, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(48, 432, 32, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(192, 384, 176, 368, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_skill_lines2()	{
	ljsdcdev_hline_tr(224, 592, 256, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(224, 592, 448, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(208, 272, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(608, 272, 432, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(208, 272, 224, 256, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(592, 448, 608, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(224, 448, 208, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(608, 272, 592, 256, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_skill_txt1(int ch)	{
	char num[50];
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	plx_fcxt_setpos(fcxt_ax, 64.0f, 64.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Learn New\nPower Up");
	plx_fcxt_setpos(fcxt_ax, 64.0f, 160.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Offensive\n"
					"Defensive\n"
					"Special 1\n"
					"Special 2\n"
					"Special 3");
	plx_fcxt_setpos(fcxt_ax, 64.0f, 400.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "SXP:\n");
	sprintf(num, "%lu", stats[ch].stats.sxp);
	plx_fcxt_draw(fcxt_ax, num);
	plx_fcxt_end(fcxt_ax);
}

static void menu_skill_txt2(int ch, int type)	{
	uint16 * ptr;
	uint8 * ptr2;
	char string[100];
	int i;

	if(type == 0)	{
		ptr = stats[ch].skills.sk_type1;
		ptr2 = stats[ch].skills.sk_t1_cht;
	}
	else if(type == 1)	{
		ptr = stats[ch].skills.sk_type2;
		ptr2 = stats[ch].skills.sk_t2_cht;
	}
	else if(type == 2)	{
		ptr = stats[ch].skills.sk_type3;
		ptr2 = stats[ch].skills.sk_t3_cht;
	}
	else if(type == 3)	{
		ptr = stats[ch].skills.sk_type4;
		ptr2 = stats[ch].skills.sk_t4_cht;
	}
	else	{
		ptr = stats[ch].skills.sk_type5;
		ptr2 = stats[ch].skills.sk_t5_cht;
	}

	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 256.0f, 288.0f, 5.0f);

	for(i = 0; i < 10; i++)	{
		if(ptr2[i] != 0)	{
			sprintf(string, "%s x%d\n", skills[ptr[i] - 1].name, ptr2[i]);
			plx_fcxt_draw(fcxt_ax, string);
		}
	}
}

static void menu_skill_txt3_fill(int ch, int type, uint16 * list)	{
	int i;
	int count = 0;

	for(i = 0; count < 10 && i < skill_count; i++)	{
		if(skills[i].typ == type + 1)	{
			if(misc_check_skilldep(ch, type, i) == 0)	{
				list[count] = i + 1;
				count++;
			}
		}
	}
}

static void menu_skill_txt3(int ch, int type, uint16 * list)	{
	int i;
	char string[100];

	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 256.0f, 288.0f, 5.0f);

	for(i = 0; i < 10; i++)	{
		if(list[i] != 0)	{
			sprintf(string, "%s %d\n", skills[list[i] - 1].name, skills[list[i] - 1].sxp_req);
			plx_fcxt_draw(fcxt_ax, string);
		}
	}
	plx_fcxt_end(fcxt_ax);
}

static void menu_stat_lines()	{
	ljsdcdev_line_tr(32, 48, 48, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(160, 48, 176, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(144, 48, 128, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(608, 48, 592, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(48, 80, 32, 64, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(176, 448, 160, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(128, 80, 144, 64, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(592, 448, 608, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 128, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 128, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(176, 592, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(176, 592, 448, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(32, 48, 64, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(144, 48, 64, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(160, 48, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(608, 48, 432, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_magic_lines()	{
	ljsdcdev_line_tr(32, 48, 48, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(224, 48, 240, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(32, 240, 48, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(192, 208, 208, 192, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(592, 208, 608, 192, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(592, 448, 608, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(208, 48, 192, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(608, 48, 592, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(608, 240, 592, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(48, 208, 32, 192, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(240, 208, 224, 192, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(48, 448, 32, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 192, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(240, 592, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 592, 224, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 192, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(240, 592, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(48, 592, 448, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(32, 48, 192, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(208, 48, 192, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(224, 48, 192, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(608, 48, 192, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(32, 240, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(608, 240, 432, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void menu_magic_txt(int character)	{
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	if(stats[character].magic.mag_lev1[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev1[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev1[0] - 1)].name, 80, 272, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev1[0] - 1)].name, 80, 272, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev1[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev1[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev1[1] - 1)].name, 208, 272, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev1[1] - 1)].name, 208, 272, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev1[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev1[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev1[2] - 1)].name, 336, 272, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev1[2] - 1)].name, 336, 272, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev1[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev1[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev1[3] - 1)].name, 464, 272, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev1[3] - 1)].name, 464, 272, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev2[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev2[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev2[0] - 1)].name, 80, 288, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev2[0] - 1)].name, 80, 288, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev2[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev2[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev2[1] - 1)].name, 208, 288, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev2[1] - 1)].name, 208, 288, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev2[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev2[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev2[2] - 1)].name, 336, 288, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev2[2] - 1)].name, 336, 288, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev2[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev2[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev2[3] - 1)].name, 464, 288, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev2[3] - 1)].name, 464, 288, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev3[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev3[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev3[0] - 1)].name, 80, 304, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev3[0] - 1)].name, 80, 304, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev3[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev3[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev3[1] - 1)].name, 208, 304, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev3[1] - 1)].name, 208, 304, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev3[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev3[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev3[2] - 1)].name, 336, 304, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev3[2] - 1)].name, 336, 304, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev3[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev3[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev3[3] - 1)].name, 464, 304, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev3[3] - 1)].name, 464, 304, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev4[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev4[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev4[0] - 1)].name, 80, 320, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev4[0] - 1)].name, 80, 320, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev4[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev4[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev4[1] - 1)].name, 208, 320, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev4[1] - 1)].name, 208, 320, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev4[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev4[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev4[2] - 1)].name, 336, 320, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev4[2] - 1)].name, 336, 320, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev4[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev4[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev4[3] - 1)].name, 464, 320, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev4[3] - 1)].name, 464, 320, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev5[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev5[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev5[0] - 1)].name, 80, 336, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev5[0] - 1)].name, 80, 336, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev5[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev5[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev5[1] - 1)].name, 208, 336, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev5[1] - 1)].name, 208, 336, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev5[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev5[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev5[2] - 1)].name, 336, 336, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev5[2] - 1)].name, 336, 336, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev5[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev5[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev5[3] - 1)].name, 464, 336, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev5[3] - 1)].name, 464, 336, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev6[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev6[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev6[0] - 1)].name, 80, 352, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev6[0] - 1)].name, 80, 352, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev6[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev6[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev6[1] - 1)].name, 208, 352, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev6[1] - 1)].name, 208, 352, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev6[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev6[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev6[2] - 1)].name, 336, 352, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev6[2] - 1)].name, 336, 352, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev6[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev6[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev6[3] - 1)].name, 464, 352, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev6[3] - 1)].name, 464, 352, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev7[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev7[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev7[0] - 1)].name, 80, 368, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev7[0] - 1)].name, 80, 368, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev7[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev7[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev7[1] - 1)].name, 208, 368, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev7[1] - 1)].name, 208, 368, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev7[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev7[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev7[2] - 1)].name, 336, 368, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev7[2] - 1)].name, 336, 368, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev7[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev7[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev7[3] - 1)].name, 464, 368, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev7[3] - 1)].name, 464, 368, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev8[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev8[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev8[0] - 1)].name, 80, 384, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev8[0] - 1)].name, 80, 384, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev8[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev8[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev8[1] - 1)].name, 208, 384, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev8[1] - 1)].name, 208, 384, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev8[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev8[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev8[2] - 1)].name, 336, 384, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev8[2] - 1)].name, 336, 384, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev8[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev8[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev8[3] - 1)].name, 464, 384, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev8[3] - 1)].name, 464, 384, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev9[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev9[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev9[0] - 1)].name, 80, 400, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev9[0] - 1)].name, 80, 400, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev9[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev9[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev9[1] - 1)].name, 208, 400, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev9[1] - 1)].name, 208, 400, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev9[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev9[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev9[2] - 1)].name, 336, 400, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev9[2] - 1)].name, 336, 400, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev9[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev9[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev9[3] - 1)].name, 464, 400, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev9[3] - 1)].name, 464, 400, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev10[0] != 0)	{
		if(magics[(stats[character].magic.mag_lev10[0] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev10[0] - 1)].name, 80, 416, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev10[0] - 1)].name, 80, 416, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev10[1] != 0)	{
		if(magics[(stats[character].magic.mag_lev10[1] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev10[1] - 1)].name, 208, 416, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev10[1] - 1)].name, 208, 416, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev10[2] != 0)	{
		if(magics[(stats[character].magic.mag_lev10[2] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev10[2] - 1)].name, 336, 416, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev10[2] - 1)].name, 336, 416, 255, 128, 128, 128);
		}
	}
	if(stats[character].magic.mag_lev10[3] != 0)	{
		if(magics[(stats[character].magic.mag_lev10[3] - 1)].typ < 64)	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev10[3] - 1)].name, 464, 416, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_text(fcxt_ax, magics[(stats[character].magic.mag_lev10[3] - 1)].name, 464, 416, 255, 128, 128, 128);
		}
	}
}

static void menu_magic_txt2()	{
	ljsdcdev_text(fcxt_ax, stats[0].name, 256, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, stats[1].name, 256, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, stats[2].name, 256, 144, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, stats[3].name, 256, 176, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_text(fcxt_ax, "HP", 368, 64, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, "MP", 432, 64, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, "Status", 496, 64, 255, options.bc.r, options.bc.g, options.bc.b);

	char foo[16];
	plx_fcxt_setsize(fcxt_ax, 12.0f);
	sprintf(foo, "%d/%d", stats[0].stats.hp_rem, stats[0].stats.hp);
	ljsdcdev_text(fcxt_ax, foo, 352, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(foo, "%d/%d", stats[1].stats.hp_rem, stats[1].stats.hp);
	ljsdcdev_text(fcxt_ax, foo, 352, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(foo, "%d/%d", stats[2].stats.hp_rem, stats[2].stats.hp);
	ljsdcdev_text(fcxt_ax, foo, 352, 144, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(foo, "%d/%d", stats[3].stats.hp_rem, stats[3].stats.hp);
	ljsdcdev_text(fcxt_ax, foo, 352, 176, 255, options.bc.r, options.bc.g, options.bc.b);

	sprintf(foo, "%d/%d", stats[0].stats.mp_rem, stats[0].stats.mp);
	ljsdcdev_text(fcxt_ax, foo, 416, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(foo, "%d/%d", stats[1].stats.mp_rem, stats[1].stats.mp);
	ljsdcdev_text(fcxt_ax, foo, 416, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(foo, "%d/%d", stats[2].stats.mp_rem, stats[2].stats.mp);
	ljsdcdev_text(fcxt_ax, foo, 416, 144, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(foo, "%d/%d", stats[3].stats.mp_rem, stats[3].stats.mp);
	ljsdcdev_text(fcxt_ax, foo, 416, 176, 255, options.bc.r, options.bc.g, options.bc.b);
	plx_fcxt_setsize(fcxt_ax, 16.0f);
}

static void menu_item_txt()	{
	char item_name[20];
	int i;
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	for(i = 0; i < 40; i++)	{
		if(itemlist[i].number != 0)	{
			sprintf(item_name, "%s x %d", items[itemlist[i].number - 1].name, itemlist[i].count);
			if(i <= 9)	{
				ljsdcdev_text(fcxt_ax, item_name, 80, 272 + i * 16, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else if(i < 19)	{
				ljsdcdev_text(fcxt_ax, item_name, 208, 272 + (i - 10) * 16, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else if(i < 29)	{
				ljsdcdev_text(fcxt_ax, item_name, 336, 272 + (i - 20) * 16, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else	{
				ljsdcdev_text(fcxt_ax, item_name, 464, 272 + (i - 30) * 16, 255, options.bc.r, options.bc.g, options.bc.b);
			}
		}
	}
}

static void menu_equip_txt(int character, int screen)	{
	ljsdcdev_text(fcxt_ax, "Hands:", 256, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, "Arms:", 256, 96, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, "Head:", 256, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, "Body:", 256, 128, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, "Feet:", 256, 144, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, "Accessory:", 256, 160, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, "Accessory:", 256, 176, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_text(fcxt_ax, equipment[stats[character].equip.equipment[0]].name, 416, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, equipment[stats[character].equip.equipment[1]].name, 416, 96, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, equipment[stats[character].equip.equipment[2]].name, 416, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, equipment[stats[character].equip.equipment[3]].name, 416, 128, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, equipment[stats[character].equip.equipment[4]].name, 416, 144, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, equipment[stats[character].equip.equipment[5]].name, 416, 160, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_text(fcxt_ax, equipment[stats[character].equip.equipment[6]].name, 416, 176, 255, options.bc.r, options.bc.g, options.bc.b);

	int i;
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	if(screen == 0)	{
		for(i = 0; i < 20; i++)	{
			if(equiplist[i] != 0)	{
				if(i <= 9)	{
					ljsdcdev_text(fcxt_ax, equipment[equiplist[i]].name, 80, 272 + i * 16, 255, options.bc.r, options.bc.g, options.bc.b);
				}
				else if(i < 19)	{
					ljsdcdev_text(fcxt_ax, equipment[equiplist[i]].name, 336, 272 + (i - 10) * 16, 255, options.bc.r, options.bc.g, options.bc.b);
				}
			}
		}
	}

	else	{
		for(i = 20; i < 40; i++)	{
			if(equiplist[i] != 0)	{
				if(i < 29)	{
					ljsdcdev_text(fcxt_ax, equipment[equiplist[i]].name, 80, 272 + (i - 20) * 16, 255, options.bc.r, options.bc.g, options.bc.b);
				}
				else	{
					ljsdcdev_text(fcxt_ax, equipment[equiplist[i]].name, 336, 272 + (i - 30) * 16, 255, options.bc.r, options.bc.g, options.bc.b);
				}
			}
		}
	}
}

static void menu_stat_txt(int character)	{
	char cl[16];
	char string[255];
	if(stats[character].stats.rank == 0)	{
		strcpy(cl, "Fighter");
	}
	else if(stats[character].stats.rank == 1)	{
		strcpy(cl, "Thief");
	}
	else if(stats[character].stats.rank == 2)	{
		strcpy(cl, "Black Mage");
	}
	else if(stats[character].stats.rank == 3)	{
		strcpy(cl, "White Mage");
	}

	plx_fcxt_setsize(fcxt_ax, 16.0f);
	ljsdcdev_text(fcxt_ax, "Stats", 48, 64, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Name: %s", stats[character].name);
	ljsdcdev_text(fcxt_ax, string, 176, 64, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Class: %s", cl);
	ljsdcdev_text(fcxt_ax, string, 176, 80, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Level %d", stats[character].stats.level);
	ljsdcdev_text(fcxt_ax, string, 176, 96, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Total Experience: %lu", stats[character].stats.exp);
	ljsdcdev_text(fcxt_ax, string, 176, 112, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "To Next Level: %lu", (25 * (int) pow(stats[character].stats.level, 2)) - stats[character].stats.exp);
	ljsdcdev_text(fcxt_ax, string, 176, 128, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "HP Remaining: %d", stats[character].stats.hp_rem);
	ljsdcdev_text(fcxt_ax, string, 176, 160, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Total HP: %d", stats[character].stats.hp);
	ljsdcdev_text(fcxt_ax, string, 176, 176, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "MP Remaining: %d", stats[character].stats.mp_rem);
	ljsdcdev_text(fcxt_ax, string, 176, 192, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Total MP: %d", stats[character].stats.mp);
	ljsdcdev_text(fcxt_ax, string, 176, 208, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Attack: %d", stats[character].stats.attack);
	ljsdcdev_text(fcxt_ax, string, 176, 240, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Strength: %d", stats[character].stats.strength);
	ljsdcdev_text(fcxt_ax, string, 176, 256, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Defense: %d", stats[character].stats.defense);
	ljsdcdev_text(fcxt_ax, string, 176, 272, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Speed: %d", stats[character].stats.speed);
	ljsdcdev_text(fcxt_ax, string, 176, 288, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Magic Defense: %d", stats[character].stats.mdef);
	ljsdcdev_text(fcxt_ax, string, 176, 304, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Magic Attack: %d", stats[character].stats.matt);
	ljsdcdev_text(fcxt_ax, string, 176, 320, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Intelligence: %d", stats[character].stats.intel);
	ljsdcdev_text(fcxt_ax, string, 176, 336, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Accuracy: %d", stats[character].stats.accuracy);
	ljsdcdev_text(fcxt_ax, string, 176, 352, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Kills %lu", stats[character].bat.kills);
	ljsdcdev_text(fcxt_ax, string, 176, 400, 255, options.tc.r, options.tc.g, options.tc.b);
	sprintf(string, "Defeats: %lu", stats[character].bat.defeats);
	ljsdcdev_text(fcxt_ax, string, 176, 416, 255, options.tc.r, options.tc.g, options.tc.b);
}

static void menu_stat_menu(int character)	{
	cont_state_t * state;
	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));
		if(state != NULL)	{
			if(state->buttons & CONT_B || state->buttons & CONT_START)	{
				thd_sleep(200);
				break;
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_stat_lines();
		plx_list_begin(PLX_LIST_TR_POLY);
		menu_stat_txt(character);
		plx_scene_end();
	}
}

static int mx = 0, my = 0;
static int ix = 0, iy = 0;

static void menu_magic_info(int character)	{
	char txt[50];
	switch(my)	{
		case 0:
			if(stats[character].magic.mag_lev1[mx] != 0)	{
				sprintf(txt, "Magic: %s", magics[stats[character].magic.mag_lev1[mx] - 1].name);
				ljsdcdev_text(fcxt_ax, txt, 48, 64, 255, options.bc.r, options.bc.g, options.bc.b);
				sprintf(txt, "Type: ");
				ljsdcdev_text(fcxt_ax, txt, 48, 96, 255, options.bc.r, options.bc.g, options.bc.b);
				sprintf(txt, "Level: %d", my + 1);
				ljsdcdev_text(fcxt_ax, txt, 48, 128, 255, options.bc.r, options.bc.g, options.bc.b);
				sprintf(txt, "Strength: %d", magics[stats[character].magic.mag_lev1[mx] - 1].str);
				ljsdcdev_text(fcxt_ax, txt, 48, 160, 255, options.bc.r, options.bc.g, options.bc.b);
				switch(magics[stats[character].magic.mag_lev1[mx] - 1].aff)	{
					case 1:
						sprintf(txt, "One Ally");
						break;
					case 2:
						sprintf(txt, "All Allies");
						break;
					case 3:
						sprintf(txt, "One's Self");
						break;
					case 6:
						sprintf(txt, "One Enemy");
						break;
					case 7:
						sprintf(txt, "All Enemies");
						break;
					case 12:
						sprintf(txt, "?");
					default:
						sprintf(txt, "Invalid");
						break;
				}
				ljsdcdev_text(fcxt_ax, txt, 48, 192, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			break;
	}
}

static void menu_equip_info(int number)	{
	char txt[50];

	if(number == 0)	{
		return;
	}

	plx_fcxt_setsize(fcxt_ax, 16.0f);
	sprintf(txt, "%s", equipment[equiplist[number]].name);
	ljsdcdev_text(fcxt_ax, txt, 48, 64, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(txt, "Attack: +%d", equipment[equiplist[number]].att);
	ljsdcdev_text(fcxt_ax, txt, 48, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(txt, "Defense: +%d", equipment[equiplist[number]].def);
	ljsdcdev_text(fcxt_ax, txt, 48, 96, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(txt, "Speed: +%d", equipment[equiplist[number]].spd);
	ljsdcdev_text(fcxt_ax, txt, 48, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(txt, "Smarts: +%d", equipment[equiplist[number]].intl);
	ljsdcdev_text(fcxt_ax, txt, 48, 128, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(txt, "Accuracy: +%d", equipment[equiplist[number]].acc);
	ljsdcdev_text(fcxt_ax, txt, 48, 144, 255, options.bc.r, options.bc.g, options.bc.b);
	sprintf(txt, "Strength: %d", equipment[equiplist[number]].str_req);
	ljsdcdev_text(fcxt_ax, txt, 48, 160, 255, options.bc.r, options.bc.g, options.bc.b);

	switch(equipment[equiplist[number]].where)	{
		case 0:
			sprintf(txt, "Where: Hands");
			break;
		case 1:
			sprintf(txt, "Where: Arms");
			break;
		case 2:
			sprintf(txt, "Where: Head");
			break;
		case 3:
			sprintf(txt, "Where: Body");
			break;
		case 4:
			sprintf(txt, "Where: Feet");
			break;
		case 5:
			sprintf(txt, "Where: Accessory");
			break;
		default:
			break;
	}

	ljsdcdev_text(fcxt_ax, txt, 48, 192, 255, options.bc.r, options.bc.g, options.bc.b);
}

static int menu_magic_sel(int character)	{
	cont_state_t * state;
	int sel = 0;
	uint64 timer = timer_ms_gettime64();

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_A && timer + 200 < timer_ms_gettime64())	{
				return sel;
			}
			if(state->buttons & CONT_B && timer + 200 < timer_ms_gettime64())	{
				thd_sleep(200);
				return -1;
			}
			if(state->buttons & CONT_DPAD_UP && timer + 200 < timer_ms_gettime64())	{
				if(sel == 0)
					sel = 3;
				else
					sel--;
				timer = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_DOWN && timer + 200 < timer_ms_gettime64())	{
				if(sel == 3)
					sel = 0;
				else
					sel++;
				timer = timer_ms_gettime64();
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_magic_lines();
		if(character != -1)	{
			ljsdcdev_arrow(mx * 128 + 64, my * 16 + 272, mx * 128 + 64, my * 16 + 256, mx * 128 + 72, my * 16 + 264, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		else	{
			ljsdcdev_arrow(ix * 128 + 64, iy * 16 + 272, ix * 128 + 64, iy * 16 + 256, ix * 128 + 72, iy * 16 + 264, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		ljsdcdev_arrow(240, sel * 32 + 80, 240, sel * 32 + 64, 250, sel * 32 + 72, 255, options.bc.r, options.bc.g, options.bc.g);
		plx_list_begin(PLX_LIST_TR_POLY);
		if(character != -1)	{
			menu_magic_txt(character);
			menu_magic_txt2();
			menu_magic_info(character);
		}
		else	{
			menu_magic_txt2();
			menu_item_txt();
		}
		plx_scene_end();
	}
	return 0;
}

static void menu_use_magic(int magic, int character)	{
	int pl;

	if(stats[character].stats.mp_rem >= (magics[magic].lev * magics[magic].lev))	{
		if(magics[magic].aff == 1)	{
			thd_sleep(200);
			if((pl = menu_magic_sel(character)) > -1)	{
				if(magics[magic].stat == 1)	{
					stats[pl].stats.hp_rem += (magics[magic].str + stats[character].stats.matt);
					if(stats[pl].stats.hp_rem > stats[pl].stats.hp)
						stats[pl].stats.hp_rem = stats[pl].stats.hp;
					stats[character].stats.mp_rem -= (magics[magic].lev * magics[magic].lev);
				}
			}
		}
	}

	thd_sleep(200);
}

static void menu_magic_menu(int character)	{
	cont_state_t * state;
	uint64 timer = timer_ms_gettime64();

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_B)	{
				thd_sleep(200);
				break;
			}

			if(state->buttons & CONT_DPAD_LEFT && timer + 200 < timer_ms_gettime64())	{
				if(mx == 0)
					mx = 3;
				else
					mx--;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_RIGHT && timer + 200 < timer_ms_gettime64())	{
				if(mx == 3)
					mx = 0;
				else
					mx++;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_UP && timer + 200 < timer_ms_gettime64())	{
				if(my == 0)
					my = 9;
				else
					my--;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_DOWN && timer + 200 < timer_ms_gettime64())	{
				if(my == 9)
					my = 0;
				else
					my++;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_A)	{
				if(my == 0)	{
					if(stats[character].magic.mag_lev1[mx] != 0 && magics[(stats[character].magic.mag_lev1[mx] - 1)].typ < 64)
						menu_use_magic(stats[character].magic.mag_lev1[mx] - 1, character);
				}
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_magic_lines();
		ljsdcdev_arrow(mx * 128 + 64, my * 16 + 272, mx * 128 + 64, my * 16 + 256, mx * 128 + 72, my * 16 + 264, 255, options.bc.r, options.bc.g, options.bc.b);
		plx_list_begin(PLX_LIST_TR_POLY);
		menu_magic_txt(character);
		menu_magic_txt2();
		menu_magic_info(character);
		plx_scene_end();
	}
}

static int menu_item_magic(int ch, int magic)	{
	cont_state_t * state;
	uint64 timer = timer_ms_gettime64();
	int sel = 0;

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_DPAD_LEFT && timer + 200 < timer_ms_gettime64())	{
				if(sel == 0)
					sel = 3;
				else
					sel--;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_RIGHT && timer + 200 < timer_ms_gettime64())	{
				if(sel == 3)
					sel = 0;
				else
					sel++;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_A)	{
				if(magics[magic].lev == 1)	{
					stats[ch].magic.mag_lev1[sel] = magic + 1;
					thd_sleep(200);
					return 0;
				}
			}
			if(state->buttons & CONT_B)	{
				thd_sleep(200);
				return -1;
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_magic_lines();
		ljsdcdev_arrow(sel * 128 + 64, (magics[magic].lev - 1) * 16 + 272, sel * 128 + 64, (magics[magic].lev - 1) * 16 + 256, sel * 128 + 72, (magics[magic].lev - 1) * 16 + 264, 255, options.bc.r, options.bc.g, options.bc.b);
		plx_list_begin(PLX_LIST_TR_POLY);
		menu_magic_txt(ch);
		menu_magic_txt2();
		menu_magic_info(ch);
		plx_scene_end();
	}
	return -1;
}

static void menu_use_item()	{
	int pl;
	int number;
	if(ix == 0)	{
		number = iy;
	}
	else if(ix == 1)	{
		number = iy + 10;
	}
	else if(ix == 2)	{
		number = iy + 20;
	}
	else	{
		number = iy + 30;
	}

	if(items[itemlist[number].number - 1].aff == 1)	{
		thd_sleep(200);
		if((pl = menu_magic_sel(-1)) > -1)	{
			if(items[itemlist[number].number - 1].eff == 1)	{
				stats[pl].stats.hp_rem += items[itemlist[number].number - 1].str;
				if(stats[pl].stats.hp_rem > stats[pl].stats.hp)
					stats[pl].stats.hp_rem = stats[pl].stats.hp;
				itemlist[number].count--;
				if(itemlist[number].count == 0)	{
					itemlist[number].number = 0;
					misc_sort_items();
				}
			}
			else if(items[itemlist[number].number - 1].eff == 2)	{
				stats[pl].stats.mp_rem += items[itemlist[number].number - 1].str;
				if(stats[pl].stats.mp_rem > stats[pl].stats.mp)
					stats[pl].stats.mp_rem = stats[pl].stats.mp;
				itemlist[number].count--;
				if(itemlist[number].count == 0)	{
					itemlist[number].number = 0;
					misc_sort_items();
				}
			}
			else if(items[itemlist[number].number - 1].eff == 128)	{
				if(stats[pl].stats.rank == 3)	{
					thd_sleep(200);
					if(menu_item_magic(pl, items[itemlist[number].number - 1].str) == 0)	{
						itemlist[number].count--;
						if(itemlist[number].count == 0)	{
							itemlist[number].number = 0;
							misc_sort_items();
						}
					}
				}
			}
			else if(items[itemlist[number].number - 1].eff == 127)	{
				if(stats[pl].stats.rank == 2)	{
					thd_sleep(200);
					if(menu_item_magic(pl, items[itemlist[number].number - 1].str) == 0)	{
						itemlist[number].count--;
						if(itemlist[number].count == 0)	{
							itemlist[number].number = 0;
							misc_sort_items();
						}
					}
				}
			}
		}
	}

	thd_sleep(200);
}

static void menu_item_menu()	{
	cont_state_t * state;
	uint64 timer = timer_ms_gettime64();

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));
		if(state != NULL)	{
			if(state->buttons & CONT_B)	{
				thd_sleep(200);
				break;
			}

			if(state->buttons & CONT_DPAD_LEFT && timer + 200 < timer_ms_gettime64())	{
				if(ix == 0)
					ix = 3;
				else
					ix--;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_RIGHT && timer + 200 < timer_ms_gettime64())	{
				if(ix == 3)
					ix = 0;
				else
					ix++;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_UP && timer + 200 < timer_ms_gettime64())	{
				if(iy == 0)
					iy = 9;
				else
					iy--;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_DOWN && timer + 200 < timer_ms_gettime64())	{
				if(iy == 9)
					iy = 0;
				else
					iy++;
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_A)	{
				menu_use_item(ix, iy);
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_magic_lines();
		ljsdcdev_arrow(ix * 128 + 64, iy * 16 + 272, ix * 128 + 64, iy * 16 + 256, ix * 128 + 72, iy * 16 + 264, 255, options.bc.r, options.bc.g, options.bc.b);
		plx_list_begin(PLX_LIST_TR_POLY);
		menu_magic_txt2();
		menu_item_txt();
		plx_scene_end();
	}
}

static void menu_equip_menu(int character)	{
	cont_state_t * state;
	uint64 timer = timer_ms_gettime64();
	int ex = 0, ey = 0, screen = 0;
	int place = 0;
	int selecting = 0;

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_B && timer + 200 < timer_ms_gettime64())	{
				if(selecting == 0)	{
					thd_sleep(200);
					break;
				}
				else	{
					selecting = 0;
					timer = timer_ms_gettime64();
				}
			}

			if(state->buttons & CONT_DPAD_LEFT && timer + 200 < timer_ms_gettime64())	{
				if(selecting == 1)	{
					if(ex == 0)
						ex = 1;
					else
						ex--;
					timer = timer_ms_gettime64();
				}
			}

			if(state->buttons & CONT_DPAD_RIGHT && timer + 200 < timer_ms_gettime64())	{
				if(selecting == 1)	{
					if(ex == 1)
						ex = 0;
					else
						ex++;
					timer = timer_ms_gettime64();
				}
			}

			if(state->buttons & CONT_DPAD_UP && timer + 200 < timer_ms_gettime64())	{
				if(selecting == 0)	{
					if(place == 0)
						place = 6;
					else
						place--;
				}
				else	{
					if(ey == 0)	{
						if(screen == 0)
							screen = 1;
						else
							screen = 0;
						ey = 9;
					}
					else
						ey--;
				}
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_DOWN && timer + 200 < timer_ms_gettime64())	{
				if(selecting == 0)	{
					if(place == 6)
						place = 0;
					else
						place++;
				}
				else	{
					if(ey == 9)	{
						if(screen == 0)
							screen = 1;
						else
							screen = 0;
						ey = 0;
					}
					else
						ey++;
				}
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_A && timer + 200 < timer_ms_gettime64())	{
				if(selecting == 0)	{
					selecting = 1;
				}
				else if(selecting == 1)	{
					if(ex == 0 && screen == 0 && equiplist[ey] != 0 && equipment[equiplist[ey]].where == place && equipment[equiplist[ey]].str_req <= stats[character].stats.strength)	{
						if(stats[character].equip.equipment[place] != 0)	{
							misc_add_equip(stats[character].equip.equipment[place]);
						}
						stats[character].equip.equipment[place] = equiplist[ey];
						equiplist[ey] = 0;
						selecting = 0;
					}
					else if(ex == 1 && screen == 0 && equiplist[ey + 10] != 0 && equipment[equiplist[ey + 10]].where == place && equipment[equiplist[ey + 10]].str_req <= stats[character].stats.strength)	{
						if(stats[character].equip.equipment[place] != 0)	{
							misc_add_equip(stats[character].equip.equipment[place]);
						}
						stats[character].equip.equipment[place] = equiplist[ey + 10];
						equiplist[ey + 10] = 0;
						selecting = 0;
					}
					else if(ex == 0 && screen == 1 && equiplist[ey + 20] != 0 && equipment[equiplist[ey + 20]].where == place && equipment[equiplist[ey + 20]].str_req <= stats[character].stats.strength)	{
						if(stats[character].equip.equipment[place] != 0)	{
							misc_add_equip(stats[character].equip.equipment[place]);
						}
						stats[character].equip.equipment[place] = equiplist[ey + 20];
						equiplist[ey + 20] = 0;
						selecting = 0;
					}
					else if(ex == 1 && screen == 1 && equiplist[ey + 30] != 0 && equipment[equiplist[ey + 30]].where == place && equipment[equiplist[ey + 30]].str_req <= stats[character].stats.strength)	{
						if(stats[character].equip.equipment[place] != 0)	{
							misc_add_equip(stats[character].equip.equipment[place]);
						}
						stats[character].equip.equipment[place] = equiplist[ey + 30];
						equiplist[ey + 30] = 0;
						selecting = 0;
					}
				}
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_Y && timer + 200 < timer_ms_gettime64())	{
				if(selecting == 0)	{
					if(stats[character].equip.equipment[place] != 0)	{
						misc_add_equip(stats[character].equip.equipment[place]);
						stats[character].equip.equipment[place] = 0;
					}
				}
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_magic_lines();
		ljsdcdev_arrow(240, place * 16 + 80, 240, place * 16 + 64, 250, place * 16 + 72, 255, options.bc.r, options.bc.g, options.bc.g);
		if(selecting == 1)	{
			ljsdcdev_arrow(ex * 256 + 64, ey * 16 + 272, ex * 256 + 64, ey * 16 + 256, ex * 256 + 72, ey * 16 + 264, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		plx_list_begin(PLX_LIST_TR_POLY);
		menu_equip_txt(character, screen);
		if(selecting == 1)	{
			if(ex == 0 && screen == 0)	{
				menu_equip_info(equiplist[ey]);
				if(equipment[equiplist[ey]].str_req > stats[character].stats.strength && equiplist[ey] != 0)	{
					ljsdcdev_text(fcxt_ax, "Can't Equip", 48, 176, 255, options.bc.r, options.bc.g, options.bc.b);
				}
			}
			else if(ex == 0 && screen == 1)	{
				menu_equip_info(equiplist[ey + 20]);
				if(equipment[equiplist[ey + 20]].str_req > stats[character].stats.strength && equiplist[ey + 20] != 0)
					ljsdcdev_text(fcxt_ax, "Can't Equip", 48, 176, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else if(ex == 1 && screen == 0)	{
				menu_equip_info(equiplist[ey + 10]);
				if(equipment[equiplist[ey + 10]].str_req > stats[character].stats.strength && equiplist[ey + 10] != 0)
					ljsdcdev_text(fcxt_ax, "Can't Equip", 48, 176, 255, options.bc.r, options.bc.g, options.bc.b);
			}
			else	{
				menu_equip_info(equiplist[ey + 30]);
				if(equipment[equiplist[ey + 30]].str_req > stats[character].stats.strength && equiplist[ey + 30] != 0)
					ljsdcdev_text(fcxt_ax, "Can't Equip", 48, 176, 255, options.bc.r, options.bc.g, options.bc.b);
			}
		}
		plx_scene_end();
	}
}

static void menu_skill_menu(int character)	{
	uint8 mode = 0;
	uint8 t1 = 0;
	uint8 t2 = 0;
	uint8 t3 = 0;
	int i;
	cont_state_t * state;
	uint64 timer = timer_ms_gettime64();
	uint16 list[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_B && timer + 200 < timer_ms_gettime64())	{
				thd_sleep(200);
				if(mode == 0)	{ 
					break;
				}
				else if(mode == 1 || mode == 2)	{
					t2 = 0;
					mode = 0;
				}
				else if(mode == 3)	{
					t3 = 0;
					for(i = 0; i < 10; i++)	{
						list[i] = 0;
					}
					mode = 1;
				}
				else if(mode == 4)	{
					t3 = 0;
					mode -= 2;
				}
			}

			if(state->buttons & CONT_A && timer + 200 < timer_ms_gettime64())	{
				if(mode == 0)	{
					if(t1 == 0)	{
						mode = 1;
					}
					else	{
						mode = 2;
					}
				}
				else if(mode == 1)	{
					menu_skill_txt3_fill(character, t2, list);
					mode = 3;
				}
				else if(mode == 2)	{
					mode = 4;
				}
				else if(mode == 3)	{
					if(stats[character].stats.sxp >= skills[list[t3] - 1].sxp_req)	{
						if(misc_add_skill(list[t3], character, t2) == 0)	{
							stats[character].stats.sxp -= skills[list[t3] - 1].sxp_req;
							for(i = 0; i < 10; i++)	{
								list[i] = 0;
							}
							menu_skill_txt3_fill(character, t2, list);
						}
					}
				}
				else if(mode == 4)	{
					if(stats[character].stats.sxp >= 10)	{
						if(t2 == 0 && stats[character].skills.sk_type1[t3] != 0 && stats[character].skills.sk_t1_cht[t3] != 10)	{
							stats[character].skills.sk_t1_cht[t3]++;
							stats[character].stats.sxp -= 10;
						}
						if(t2 == 1 && stats[character].skills.sk_type2[t3] != 0 && stats[character].skills.sk_t2_cht[t3] != 10)	{
							stats[character].skills.sk_t2_cht[t3]++;
							stats[character].stats.sxp -= 10;
						}
						if(t2 == 2 && stats[character].skills.sk_type3[t3] != 0 && stats[character].skills.sk_t3_cht[t3] != 10)	{
							stats[character].skills.sk_t3_cht[t3]++;
							stats[character].stats.sxp -= 10;
						}
						if(t2 == 3 && stats[character].skills.sk_type4[t3] != 0 && stats[character].skills.sk_t4_cht[t3] != 10)	{
							stats[character].skills.sk_t4_cht[t3]++;
							stats[character].stats.sxp -= 10;
						}
						if(t2 == 4 && stats[character].skills.sk_type5[t3] != 0 && stats[character].skills.sk_t5_cht[t3] != 10)	{
							stats[character].skills.sk_t5_cht[t3]++;
							stats[character].stats.sxp -= 10;
						}
					}
				}
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_UP && timer + 200 < timer_ms_gettime64())	{
				if(mode == 0)	{
					if(t1 == 0)	{
						t1 = 1;
					}
					else	{
						t1 = 0;
					}
				}
				else if(mode == 1 || mode == 2)	{
					if(t2 == 0)	{
						t2 = 4;
					}
					else	{
						t2--;
					}
				}
				else	{
					if(t3 == 0)	{
						t3 = 9;
					}
					else	{
						t3--;
					}
				}
				timer = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_DOWN && timer + 200 < timer_ms_gettime64())	{
				if(mode == 0)	{
					if(t1 == 0)	{
						t1 = 1;
					}
					else	{
						t1 = 0;
					}
				}
				else if(mode == 1 || mode == 2)	{
					if(t2 == 4)	{
						t2 = 0;
					}
					else	{
						t2++;
					}
				}
				else	{
					if(t3 == 9)	{
						t3 = 0;
					}
					else	{
						t3++;
					}
				}
				timer = timer_ms_gettime64();
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_skill_lines();
		if(mode > 2)	{
			menu_skill_lines2();
		}
		plx_list_begin(PLX_LIST_TR_POLY);
		menu_skill_txt1(character);
		if(mode == 4)	{
			menu_skill_txt2(character, t2);
		}
		else if(mode == 3)	{
			menu_skill_txt3(character, t2, list);
		}
		ljsdcdev_arrow(48, 64 + 16 * t1, 48, 48 + t1 * 16, 64, 56 + t1 * 16, 255, options.bc.r, options.bc.g, options.bc.b);
		if(mode != 0)	{
			ljsdcdev_arrow(48, 160 + 16 * t2, 48, 144 + t2 * 16, 64, 152 + t2 * 16, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		if(mode > 2)	{
			ljsdcdev_arrow(224, 288 + 16 * t3, 224, 272 + t3 * 16, 240, 280 + t3 * 16, 255, options.bc.r, options.bc.g, options.bc.b);
		}
		plx_scene_end();
	}
}

static void menu_sel(int menu)	{
	int sel1 = 0;
	cont_state_t * state;
	uint64 time_since = timer_ms_gettime64();
	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_B || state->buttons & CONT_START)	{
				thd_sleep(200);
				break;
			}
			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
				thd_sleep(200);
				if(menu == 1)	{
					menu_stat_menu(sel1);
				}
				else if(menu == 0)	{
					menu_magic_menu(sel1);
				}
				else if(menu == 2)	{
					menu_equip_menu(sel1);
				}
				else if(menu == 3)	{
					menu_skill_menu(sel1);
				}
				break;
			}
			if(state->buttons & CONT_DPAD_RIGHT && time_since + 200 < timer_ms_gettime64())	{
				if(sel1 <= 2)
					sel1++;
				else
					sel1 = 0;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_LEFT && time_since + 200 < timer_ms_gettime64())	{
				if(sel1 >= 1)
					sel1--;
				else
					sel1 = 3;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				if(sel1 == 0 || sel1 == 1)
					sel1 += 2;
				else
					sel1 -= 2;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				if(sel1 == 0 || sel1 == 1)
					sel1 += 2;
				else
					sel1 -= 2;
				time_since = timer_ms_gettime64();
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_draw_ul();
		menu_draw_ll();
		menu_draw_ur();
		menu_draw_lr();
		menu_draw_hl();
		menu_draw_vl();
		if(menu == 0)
			menu_draw_arrow(2);
		else if(menu == 1)
			menu_draw_arrow(4);
		else if(menu == 2)
			menu_draw_arrow(1);
		else if(menu == 3)
			menu_draw_arrow(3);
		plx_list_begin(PLX_LIST_TR_POLY);
		plx_fcxt_begin(fcxt_ax);
		menu_draw_txt();
		menu_draw_names();
		menu_draw_hp();
		menu_draw_mp();
		menu_draw_class();
		menu_draw_lvl();
		menu_draw_goldtime();
		plx_fcxt_end(fcxt_ax);
		menu_draw_img();

		if(sel1 == 0)
			ljsdcdev_arrow(320, 256, 288, 256, 304, 224, 255, options.bc.r, options.bc.g, options.bc.b);
		else if(sel1 == 1)
			ljsdcdev_arrow(528, 256, 496, 256, 512, 224, 255, options.bc.r, options.bc.g, options.bc.b);
		else if(sel1 == 2)
			ljsdcdev_arrow(288, 224, 320, 224, 304, 256, 255, options.bc.r, options.bc.g, options.bc.b);
		else if(sel1 == 3)
			ljsdcdev_arrow(496, 224, 528, 224, 512, 256, 255, options.bc.r, options.bc.g, options.bc.b);

		plx_scene_end();
	}
}

static void menu_quit()	{
	int sel = 1;
	cont_state_t * state;
	uint64 time_since = timer_ms_gettime64();
	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));
		if(state != NULL)	{
			if(state->buttons & CONT_DPAD_RIGHT && time_since + 200 < timer_ms_gettime64())	{
				sel++;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_LEFT && time_since + 200 < timer_ms_gettime64())	{
				sel--;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_A)	{
				if(sel == 1)	{
					thd_sleep(200);
					break;
				}
				else
					exit(0);
			}
		}

		if(sel > 1)
			sel = 0;
		else if(sel < 0)
			sel = 1;

		plx_scene_begin();
		plx_list_begin(PLX_LIST_TR_POLY);
		plx_fcxt_begin(fcxt_ax);
		plx_fcxt_setsize(fcxt_ax, 32.0f);
		plx_fcxt_setpos(fcxt_ax, 48.0f, 200.0f, 5.0f);
		plx_fcxt_draw(fcxt_ax, "Are you sure you want to");
		plx_fcxt_setpos(fcxt_ax, 256.0f, 232.0f, 5.0f);
		plx_fcxt_draw(fcxt_ax, "quit?");
		plx_fcxt_setpos(fcxt_ax, 220.0f, 350.0f, 5.0f);
		plx_fcxt_draw(fcxt_ax, "Yes");
		plx_fcxt_setpos(fcxt_ax, 340.0f, 350.0f, 5.0f);
		plx_fcxt_draw(fcxt_ax, "No");

		if(sel == 0)
			ljsdcdev_arrow(180, 350, 180, 318, 200, 334, 255, 255, 255, 255);
		else
			ljsdcdev_arrow(300, 350, 300, 318, 320, 334, 255, 255, 255, 255);
		plx_scene_end();
	}
}

void menu_do_menu()	{
	cont_state_t * state;
	int sel = 0;
	uint64 time_since = timer_ms_gettime64();
	pvr_set_bg_color(options.mc.r / 255, options.mc.g / 255, options.mc.b / 255);
	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));
		if(state != NULL)	{
			if(state->buttons & CONT_B)
				break;
			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				sel++;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				sel--;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_A)	{
				if(sel == 0)	{
					thd_sleep(200);
					menu_item_menu();
				}
				if(sel == 1)	{
					thd_sleep(200);
					menu_sel(2);
				}
				else if(sel == 2)	{
					thd_sleep(200);
					menu_sel(0);
				}
				else if(sel == 3)	{
					thd_sleep(200);
					menu_sel(3);
				}
				else if(sel == 4)	{
					thd_sleep(200);
					menu_sel(1);
				}
				else if(sel == 5)	{
					thd_sleep(200);
					save_game();
				}
				else if(sel == 6)	{
					thd_sleep(200);
					menu_quit();
				}
			}
		}

		if(sel > 6)
			sel = 0;
		else if(sel < 0)
			sel = 6;

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		menu_draw_ul();
		menu_draw_ll();
		menu_draw_ur();
		menu_draw_lr();
		menu_draw_hl();
		menu_draw_vl();
		menu_draw_arrow(sel);
		plx_list_begin(PLX_LIST_TR_POLY);
		plx_fcxt_begin(fcxt_ax);
		menu_draw_txt();
		menu_draw_names();
		menu_draw_hp();
		menu_draw_mp();
		menu_draw_class();
		menu_draw_lvl();
		menu_draw_goldtime();
		plx_fcxt_end(fcxt_ax);
		menu_draw_img();
		plx_scene_end();
		misc_update_timer();
	}
}
