/*	msgs.c -- ljsdcdev
	Message Boxes
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

void msg_box_plain(const char * text, uint8 r, uint8 g, uint8 b)	{
	pvr_poly_hdr_t hdr;
	pvr_poly_cxt_t cxt;
	pvr_vertex_t vert;

	pvr_poly_cxt_col(&cxt, PVR_LIST_TR_POLY);
	pvr_poly_compile(&hdr, &cxt);

	pvr_prim(&hdr, sizeof(hdr));

	vert.flags = PVR_CMD_VERTEX;
	vert.x = 0.0f;
	vert.y = 479.0f;
	vert.z = 5.0f;
	vert.u = 0.0f;
	vert.v = 0.0f;
	vert.argb = PVR_PACK_COLOR(0.5f, r / 255.0f, g / 255.0f, b / 255.0f);
	vert.oargb = 0;
	pvr_prim(&vert, sizeof(vert));

	vert.x = 0.0f;
	vert.y = 360.0f;
	pvr_prim(&vert, sizeof(vert));

	vert.x = 639.0f;
	vert.y = 479.0f;
	pvr_prim(&vert, sizeof(vert));

	vert.flags = PVR_CMD_VERTEX_EOL;
	vert.x = 639.0f;
	vert.y = 360.0f;
	pvr_prim(&vert, sizeof(vert));

	plx_fcxt_setsize(fcxt_ax, 16.0f);
	ljsdcdev_text(fcxt_ax, text, 32, 376, 255, 255, 255, 255);
}
