/*	name.c -- ljsdcdev
	Name Entry
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

static void draw_alphabet()	{
	int i, j = 0, k = 0;

	plx_fcxt_setsize(fcxt_ax, 32.0f);
	plx_fcxt_begin(fcxt_ax);
	for(i = 65; i < 91; i++)	{
		if(j * 32 + 32 >= 448)	{
			j = 0;
			k++;
		}
		plx_fcxt_setpos(fcxt_ax, j * 32 + 112, k * 32 + 252, 5.0f);
		plx_fcxt_draw_ch(fcxt_ax, i);
		j++;
	}
	for(i = 97; i < 123; i++)	{
		if(j * 32 + 32 >= 448)	{
			j = 0;
			k++;
		}
		plx_fcxt_setpos(fcxt_ax, j * 32 + 112, k * 32 + 252, 5.0f);
		plx_fcxt_draw_ch(fcxt_ax, i);
		j++;
	}
	for(i = 48; i < 58; i++)	{
		if(j * 32 + 32 >= 448)	{
			j = 0;
			k++;
		}
		plx_fcxt_setpos(fcxt_ax, j * 32 + 112, k * 32 + 252, 5.0f);
		plx_fcxt_draw_ch(fcxt_ax, i);
		j++;
	}
	for(i = 45; i < 47; i++)	{
		if(j * 32 + 32 >= 448)	{
			j = 0;
			k++;
		}
		plx_fcxt_setpos(fcxt_ax, j * 32 + 112, k * 32 + 252, 5.0f);
		plx_fcxt_draw_ch(fcxt_ax, i);
		j++;
	}
	plx_fcxt_end(fcxt_ax);
}

static void draw_string(const char * string)	{
	int number = 0;

	plx_fcxt_begin(fcxt_ax);
	while(1)	{
		if(string[number] == 0)
			break;

		plx_fcxt_setpos(fcxt_ax, number * 32 + 224, 186, 5.0f);
		plx_fcxt_draw_ch(fcxt_ax, string[number]);

		number++;
	}
	plx_fcxt_end(fcxt_ax);
}

void name_set(int pl)	{
	cont_state_t * state;
	char letter = 65;
	int xpos = 0, ypos = 0;
	int number = 0;
	pvr_poly_cxt_t cxt;
	pvr_poly_hdr_t hdr;
	pvr_vertex_t vert;
	uint64 time_since = timer_ms_gettime64();

	pvr_poly_cxt_col(&cxt, PVR_LIST_TR_POLY);
	pvr_poly_compile(&hdr, &cxt);

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));
		if(state != NULL)	{
			if(state->buttons & CONT_DPAD_LEFT && time_since + 200 < timer_ms_gettime64())	{
				xpos--;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_RIGHT && time_since + 200 < timer_ms_gettime64())	{
				xpos++;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				ypos++;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				ypos--;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_START)
				break;
			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64() && number < 6)	{
				if(ypos == 0)
					letter = 65 + xpos;
				if(ypos == 1)
					letter = 78 + xpos;
				if(ypos == 2)
					letter = 97 + xpos;
				if(ypos == 3)
					letter = 110 + xpos;
				if(ypos == 4)	{
					if(xpos < 10)
						letter = 48 + xpos;
					else if(xpos == 10)
						letter = 45;
					else if(xpos == 11)
						letter = 46;
					else if(xpos == 12)
						letter = 32;
				}
				stats[pl].name[number] = letter;
				number++;
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64() && number > 0)	{
				number--;
				time_since = timer_ms_gettime64();
			}
		}

		if(xpos > 12)
			xpos = 0;
		else if(xpos < 0)
			xpos = 12;

		if(ypos > 4)
			ypos = 0;
		else if(ypos < 0)
			ypos = 4;

		if(number == 6)
			number = 5;

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		plx_list_begin(PLX_LIST_TR_POLY);
		draw_alphabet();
		draw_string(stats[pl].name);
		plx_fcxt_begin(fcxt_ax);
		plx_fcxt_setpos(fcxt_ax, 64, 64, 5.0f);
		plx_fcxt_draw(fcxt_ax, "Name Entry");
		plx_fcxt_setpos(fcxt_ax, 64, 96, 5.0f);
		plx_fcxt_setsize(fcxt_ax, 16.0f);
		plx_fcxt_draw(fcxt_ax, "START - Confirms, B - Backspace, A - Select");
		plx_fcxt_end(fcxt_ax);
		plx_txr_send_hdr(stats[pl].images.splayer, PLX_LIST_TR_POLY, 0);
		plx_spr_fnd(&dr_state, 32.0f, 32.0f, 112.0f, 170.0f, 5.0f, 1.0f, 1, 1, 1);

		pvr_prim(&hdr, sizeof(hdr));
		vert.flags = PVR_CMD_VERTEX;
		vert.x = xpos * 32 + 108;
		vert.y = ypos * 32 + 256;
		vert.z = 5.0f;
		vert.u = 0.0f;
		vert.v = 0.0f;
		vert.argb = PVR_PACK_COLOR(0.5f, 0.654f, 0.56f, 0.875f);
		vert.oargb = 0;
		pvr_prim(&vert, sizeof(vert));

		vert.y = ypos * 32 + 224;
		pvr_prim(&vert, sizeof(vert));

		vert.x = xpos * 32 + 144;
		vert.y = ypos * 32 + 256;
		pvr_prim(&vert, sizeof(vert));

		vert.flags = PVR_CMD_VERTEX_EOL;
		vert.y = ypos * 32 + 224;
		pvr_prim(&vert, sizeof(vert));

		pvr_prim(&hdr, sizeof(hdr));

		vert.flags = PVR_CMD_VERTEX;
		vert.x = 220 + number * 32;
		vert.y = 186;
		pvr_prim(&vert, sizeof(vert));

		vert.y = 154;
		pvr_prim(&vert, sizeof(vert));

		vert.x = 256 + number * 32;
		vert.y = 186;
		pvr_prim(&vert, sizeof(vert));

		vert.flags = PVR_CMD_VERTEX_EOL;
		vert.y = 154;
		pvr_prim(&vert, sizeof(vert));
		plx_scene_end();
	}
}
