/* 	save.c -- ljsdcdev
	Saving/loading utility functions
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

/* Convert from stat_data_t to stats_data_t */
stats_data_t stat_to_stats(stat_data_t src)	{
	stats_data_t dst;
	int i;

	strcpy(dst.name, src.name);

	dst.stats.attack = src.stats.attack;
	dst.stats.defense = src.stats.defense;
	dst.stats.speed = src.stats.speed;
	dst.stats.strength = src.stats.strength;
	dst.stats.mdef = src.stats.mdef;
	dst.stats.matt = src.stats.matt;
	dst.stats.intel = src.stats.intel;
	dst.stats.accuracy = src.stats.accuracy;
	dst.stats.hp = src.stats.hp;
	dst.stats.hp_rem = src.stats.hp_rem;
	dst.stats.mp = src.stats.mp;
	dst.stats.mp_rem = src.stats.mp_rem;
	dst.stats.level = src.stats.level;
	dst.stats.exp = src.stats.exp;
	dst.stats.rank = src.stats.rank;
	dst.stats.sxp = src.stats.sxp;

	for(i = 0; i < 4; i++)	{
		dst.magic.mag_lev1[i] = src.magic.mag_lev1[i];
		dst.magic.mag_lev2[i] = src.magic.mag_lev2[i];
		dst.magic.mag_lev3[i] = src.magic.mag_lev3[i];
		dst.magic.mag_lev4[i] = src.magic.mag_lev4[i];
		dst.magic.mag_lev5[i] = src.magic.mag_lev5[i];
		dst.magic.mag_lev6[i] = src.magic.mag_lev6[i];
		dst.magic.mag_lev7[i] = src.magic.mag_lev7[i];
		dst.magic.mag_lev8[i] = src.magic.mag_lev8[i];
		dst.magic.mag_lev9[i] = src.magic.mag_lev9[i];
		dst.magic.mag_lev10[i] = src.magic.mag_lev10[i];
	}

	for(i = 0; i < 10; i++)	{
		dst.skills.sk_type1[i] = src.skills.sk_type1[i];
		dst.skills.sk_type2[i] = src.skills.sk_type2[i];
		dst.skills.sk_type3[i] = src.skills.sk_type3[i];
		dst.skills.sk_type4[i] = src.skills.sk_type4[i];
		dst.skills.sk_type5[i] = src.skills.sk_type5[i];

		dst.skills.sk_t1_chl[i] = src.skills.sk_t1_chl[i];
		dst.skills.sk_t2_chl[i] = src.skills.sk_t2_chl[i];
		dst.skills.sk_t3_chl[i] = src.skills.sk_t3_chl[i];
		dst.skills.sk_t4_chl[i] = src.skills.sk_t4_chl[i];
		dst.skills.sk_t5_chl[i] = src.skills.sk_t5_chl[i];

		dst.skills.sk_t1_cht[i] = src.skills.sk_t1_cht[i];
		dst.skills.sk_t2_cht[i] = src.skills.sk_t2_cht[i];
		dst.skills.sk_t3_cht[i] = src.skills.sk_t3_cht[i];
		dst.skills.sk_t4_cht[i] = src.skills.sk_t4_cht[i];
		dst.skills.sk_t5_cht[i] = src.skills.sk_t5_cht[i];

		dst.equip.equipment[i] = src.equip.equipment[i];
	}

	/* Battle statistics */
	dst.bat.kills = src.bat.kills;
	dst.bat.defeats = src.bat.defeats;

	return dst;
}

/* Convert from stats_data_t to stat_data_t */
stat_data_t stats_to_stat(stats_data_t src)	{
	stat_data_t dst;
	int i;

	strcpy(dst.name, src.name);

	dst.stats.attack = src.stats.attack;
	dst.stats.defense = src.stats.defense;
	dst.stats.speed = src.stats.speed;
	dst.stats.strength = src.stats.strength;
	dst.stats.mdef = src.stats.mdef;
	dst.stats.matt = src.stats.matt;
	dst.stats.intel = src.stats.intel;
	dst.stats.accuracy = src.stats.accuracy;
	dst.stats.hp = src.stats.hp;
	dst.stats.hp_rem = src.stats.hp_rem;
	dst.stats.mp = src.stats.mp;
	dst.stats.mp_rem = src.stats.mp_rem;
	dst.stats.level = src.stats.level;
	dst.stats.exp = src.stats.exp;
	dst.stats.rank = src.stats.rank;
	dst.stats.sxp = src.stats.sxp;

	for(i = 0; i < 4; i++)	{
		dst.magic.mag_lev1[i] = src.magic.mag_lev1[i];
		dst.magic.mag_lev2[i] = src.magic.mag_lev2[i];
		dst.magic.mag_lev3[i] = src.magic.mag_lev3[i];
		dst.magic.mag_lev4[i] = src.magic.mag_lev4[i];
		dst.magic.mag_lev5[i] = src.magic.mag_lev5[i];
		dst.magic.mag_lev6[i] = src.magic.mag_lev6[i];
		dst.magic.mag_lev7[i] = src.magic.mag_lev7[i];
		dst.magic.mag_lev8[i] = src.magic.mag_lev8[i];
		dst.magic.mag_lev9[i] = src.magic.mag_lev9[i];
		dst.magic.mag_lev10[i] = src.magic.mag_lev10[i];
	}

	for(i = 0; i < 10; i++)	{
		dst.skills.sk_type1[i] = src.skills.sk_type1[i];
		dst.skills.sk_type2[i] = src.skills.sk_type2[i];
		dst.skills.sk_type3[i] = src.skills.sk_type3[i];
		dst.skills.sk_type4[i] = src.skills.sk_type4[i];
		dst.skills.sk_type5[i] = src.skills.sk_type5[i];

		dst.skills.sk_t1_chl[i] = src.skills.sk_t1_chl[i];
		dst.skills.sk_t2_chl[i] = src.skills.sk_t2_chl[i];
		dst.skills.sk_t3_chl[i] = src.skills.sk_t3_chl[i];
		dst.skills.sk_t4_chl[i] = src.skills.sk_t4_chl[i];
		dst.skills.sk_t5_chl[i] = src.skills.sk_t5_chl[i];

		dst.skills.sk_t1_cht[i] = src.skills.sk_t1_cht[i];
		dst.skills.sk_t2_cht[i] = src.skills.sk_t2_cht[i];
		dst.skills.sk_t3_cht[i] = src.skills.sk_t3_cht[i];
		dst.skills.sk_t4_cht[i] = src.skills.sk_t4_cht[i];
		dst.skills.sk_t5_cht[i] = src.skills.sk_t5_cht[i];

		dst.equip.equipment[i] = src.equip.equipment[i];
	}

	/* other stuff */
	dst.ally = 1;

	/* Image Loading */
	if(dst.stats.rank == 0)	{
		dst.images.splayer = plx_txr_load("/cd/images/fighter.png", 1, PVR_TXRLOAD_16BPP);
	}
	else if(dst.stats.rank == 1)	{
		dst.images.splayer = plx_txr_load("/cd/images/thief.png", 1, PVR_TXRLOAD_16BPP);
	}
	else if(dst.stats.rank == 2)	{
		dst.images.splayer = plx_txr_load("/cd/images/bkmage.png", 1, PVR_TXRLOAD_16BPP);
	}
	else if(dst.stats.rank == 3)	{
		dst.images.splayer = plx_txr_load("/cd/images/wtmage.png", 1, PVR_TXRLOAD_16BPP);
	}

	/* Battle statistics */
	dst.bat.kills = src.bat.kills;
	dst.bat.defeats = src.bat.defeats;

	return dst;
}

void save_game()	{
	save_data_t save;

	/* put our stats in */
	save.stats.p1 = stat_to_stats(stats[0]);
	save.stats.p2 = stat_to_stats(stats[1]);
	save.stats.p3 = stat_to_stats(stats[2]);
	save.stats.p4 = stat_to_stats(stats[3]);

	/* map stuffs */
	save.map.x = posx;
	save.map.y = posy;
	save.map.num = mapnum;

	/* misc. */
	int i;
	for(i = 0; i < 40; i++)	{
		save.items[i][0] = itemlist[i].number;
		save.items[i][1] = itemlist[i].count;
		save.equip[i] = equiplist[i];
	}

	for(i = 0; i < 4096; i++)	{
		save.switches[i] = switches[i];
	}

	save.time = gtime;
	save.gold = gold;

	save.opts = options;

	/* save it */
	vmu_select(&save, 0);
}

int load_game()	{
	save_data_t save;

	/* read it */
	if(vmu_select(&save, 1) == -1)	{
		return -1;
	}

	/* put our stats in */
	stats[0] = stats_to_stat(save.stats.p1);
	stats[1] = stats_to_stat(save.stats.p2);
	stats[2] = stats_to_stat(save.stats.p3);
	stats[3] = stats_to_stat(save.stats.p4);

	/* map stuffs */
	posx = save.map.x;
	posy = save.map.y;
	mapnum = save.map.num;

	/* misc. */
	int i;
	for(i = 0; i < 40; i++)	{
		itemlist[i].number = save.items[i][0];
		itemlist[i].count = save.items[i][1];
		equiplist[i] = save.equip[i];
	}

	for(i = 0; i < 4096; i++)	{
		switches[i] = save.switches[i];
	}

	options = save.opts;

	gtime = save.time;
	gold = save.gold;

	return 0;
}
