/*	shop.c -- ljsdcdev
	Buying and selling of goods
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

static void shop_basic_lines()	{
	ljsdcdev_hline_tr(128, 512, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(128, 512, 96, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 144, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 144, 192, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_vline_tr(112, 48, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(528, 48, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(64, 128, 176, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(160, 128, 176, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(512, 96, 528, 80, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(528, 48, 512, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(112, 48, 128, 32, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(128, 96, 112, 80, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(144, 192, 160, 176, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(64, 128, 80, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(160, 128, 144, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(80, 192, 64, 176, 255, options.bc.r, options.bc.g, options.bc.b);
}

static inline void shop_basic_arrow(int num)	{
	ljsdcdev_arrow(80, 16 * num + 144, 80, 16 * num + 128, 96, 16 * num + 136, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void shop_equipment_lines()	{
	ljsdcdev_hline_tr(80, 224, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 224, 368, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(64, 224, 352, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(240, 224, 352, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(224, 368, 240, 352, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(240, 224, 224, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(64, 224, 80, 208, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(80, 368, 64, 352, 255, options.bc.r, options.bc.g, options.bc.b);
}

static void shop_buysell_lines()	{
	ljsdcdev_hline_tr(272, 576, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(272, 576, 448, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(256, 128, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(592, 128, 432, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(576, 448, 592, 432, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(592, 128, 576, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(256, 128, 272, 112, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(272, 448, 256, 432, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_vline_tr(64, 384, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_vline_tr(240, 384, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 224, 368, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_hline_tr(80, 224, 432, 255, options.bc.r, options.bc.g, options.bc.b);

	ljsdcdev_line_tr(64, 384, 80, 368, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(224, 432, 240, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(80, 432, 64, 416, 255, options.bc.r, options.bc.g, options.bc.b);
	ljsdcdev_line_tr(240, 384, 224, 368, 255, options.bc.r, options.bc.g, options.bc.b);
}

static inline void shop_buysell_arrow(int sel)	{
	ljsdcdev_arrow(272, 16 * sel + 144, 272, 16 * sel + 128, 288, 16 * sel + 136, 255, options.bc.r, options.bc.g, options.bc.b);
}

static inline void shop_draw_title(char * title)	{
	plx_fcxt_setsize(fcxt_ax, 22.0f);
	plx_fcxt_setpos(fcxt_ax, 128.0f, 80.0f, 5.0f);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_draw(fcxt_ax, title);
	plx_fcxt_end(fcxt_ax);
}

static void shop_basic_text()	{
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 96.0f, 144.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Buy\n"
					"Sell\n"
					"Exit\n");
	plx_fcxt_end(fcxt_ax);
}

static void shop_equipment_info(int number)	{
	char txt[50];

	if(number != 0)	{
		plx_fcxt_setsize(fcxt_ax, 16.0f);
		sprintf(txt, "%s", equipment[number].name);
		ljsdcdev_text(fcxt_ax, txt, 96, 224, 255, options.bc.r, options.bc.g, options.bc.b);
		sprintf(txt, "Attack: +%d", equipment[number].att);
		ljsdcdev_text(fcxt_ax, txt, 96, 240, 255, options.bc.r, options.bc.g, options.bc.b);
		sprintf(txt, "Defense: +%d", equipment[number].def);
		ljsdcdev_text(fcxt_ax, txt, 96, 256, 255, options.bc.r, options.bc.g, options.bc.b);
		sprintf(txt, "Speed: +%d", equipment[number].spd);
		ljsdcdev_text(fcxt_ax, txt, 96, 272, 255, options.bc.r, options.bc.g, options.bc.b);
		sprintf(txt, "Smarts: +%d", equipment[number].intl);
		ljsdcdev_text(fcxt_ax, txt, 96, 288, 255, options.bc.r, options.bc.g, options.bc.b);
		sprintf(txt, "Accuracy: +%d", equipment[number].acc);
		ljsdcdev_text(fcxt_ax, txt, 96, 304, 255, options.bc.r, options.bc.g, options.bc.b);
		sprintf(txt, "Strength: %d", equipment[number].str_req);
		ljsdcdev_text(fcxt_ax, txt, 96, 320, 255, options.bc.r, options.bc.g, options.bc.b);

		switch(equipment[number].where)	{
			case 0:
				sprintf(txt, "Where: Hands");
				break;
			case 1:
				sprintf(txt, "Where: Arms");
				break;
			case 2:
				sprintf(txt, "Where: Head");
				break;
			case 3:
				sprintf(txt, "Where: Body");
				break;
			case 4:
				sprintf(txt, "Where: Feet");
				break;
				case 5:
				sprintf(txt, "Where: Accessory");
				break;
			default:
				break;
		}

		ljsdcdev_text(fcxt_ax, txt, 96, 352, 255, options.bc.r, options.bc.g, options.bc.b);
	}
}

static void shop_buysell_names1(uint8 * numbers, int itemcount, int offset, int type)	{
	int i;
	char string[100];
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 304.0f, 144.0f, 5.0f);
	if(type == 0)	{
		for(i = offset; i < itemcount && i < offset + 19; i++)	{
			if(numbers[i] != 0)	{
				sprintf(string, "%s\n", items[numbers[i] - 1].name);
				plx_fcxt_draw(fcxt_ax, string);
			}
		}

		plx_fcxt_setpos(fcxt_ax, 494.0f, 144.0f, 5.0f);
		for(i = offset; i < itemcount && i < offset + 19; i++)	{
			if(numbers[i] != 0)	{
				sprintf(string, "%d\n", items[numbers[i] - 1].cost);
				plx_fcxt_draw(fcxt_ax, string);
			}
		}
	}
	else if(type == 1)	{
		for(i = offset; i < itemcount && i < offset + 19; i++)	{
			if(numbers[i] != 0)	{
				sprintf(string, "%s\n", equipment[numbers[i]].name);
				plx_fcxt_draw(fcxt_ax, string);
			}
		}

		plx_fcxt_setpos(fcxt_ax, 494.0f, 144.0f, 5.0f);
		for(i = offset; i < itemcount && i < offset + 19; i++)	{
			if(numbers[i] != 0)	{
				sprintf(string, "%d\n", equipment[numbers[i]].cost);
				plx_fcxt_draw(fcxt_ax, string);
			}
		}
	}
	plx_fcxt_end(fcxt_ax);
}

static void shop_buysell_names2(int itemcount, int offset)	{
	int i;
	char string[100];
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setpos(fcxt_ax, 304.0f, 144.0f, 5.0f);
	for(i = offset; i < itemcount && i < offset + 19; i++)	{
		if(itemlist[i].number != 0)	{
			sprintf(string, "%s\n", items[itemlist[i].number].name);
			plx_fcxt_draw(fcxt_ax, string);
		}
	}
	plx_fcxt_setpos(fcxt_ax, 494.0f, 144.0f, 5.0f);
	for(i = offset; i < itemcount && i < offset + 19; i++)	{
		if(itemlist[i].number != 0)	{
			sprintf(string, "%d\n", items[itemlist[i].number].cost);
			plx_fcxt_draw(fcxt_ax, string);
		}
	}
	plx_fcxt_end(fcxt_ax);
}

static void shop_buysell_gold()	{
	char txt[50];
	plx_fcxt_begin(fcxt_ax);
	plx_fcxt_setsize(fcxt_ax, 16.0f);
	plx_fcxt_setpos(fcxt_ax, 80.0f, 400.0f, 5.0f);
	plx_fcxt_draw(fcxt_ax, "Gold:");
	plx_fcxt_setpos(fcxt_ax, 80.0f, 416.0f, 5.0f);
	sprintf(txt, "%lu G", gold);
	plx_fcxt_draw(fcxt_ax, txt);
	plx_fcxt_end(fcxt_ax);
}

static void shop_buy(uint8 * itemnums, int itemcount, char * name, int type)	{
	int sel = 0;
	int offset = 0;
	cont_state_t * state;
	uint64 time_since = timer_ms_gettime64();

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
				thd_sleep(200);
				break;
			}

			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
				if(type == 1)	{
					if(gold >= equipment[itemnums[sel]].cost)	{
						gold -= equipment[itemnums[sel]].cost;
						misc_add_equip(itemnums[sel]);
						misc_sort_equip();
					}
				}
				else if(type == 0)	{
					if(gold >= items[itemnums[sel] - 1].cost)	{
						gold -= items[itemnums[sel] - 1].cost;
						misc_add_item(itemnums[sel], 1);
						misc_sort_items();
					}
				}
				time_since = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				if(sel < itemcount - 1)	{
					sel++;
					if(sel - offset >= 19)	{
						offset++;
					}
				}
				time_since = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				if(sel > 0)	{
					sel--;
					if(sel - offset < 0)	{
						offset--;
					}
				}
				time_since = timer_ms_gettime64();
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);

		shop_basic_lines();
		shop_basic_arrow(0);

		if(type == 1)	{
			shop_equipment_lines();
		}

		shop_buysell_lines();
		shop_buysell_arrow(sel - offset);

		plx_list_begin(PLX_LIST_TR_POLY);
		shop_draw_title(name);
		shop_basic_text();
		if(type == 1)	{
			shop_equipment_info(itemnums[sel]);
		}
		shop_buysell_names1(itemnums, itemcount, offset, type);
		shop_buysell_gold();
		plx_scene_end();
	}
}

static void shop_sell(int type, char * name)	{
	int sel = 0;
	int offset = 0;
	cont_state_t * state;
	int count;
	uint64 time_since = timer_ms_gettime64();

	if(type == 0)	{
		count = misc_get_itcount();
	}
	else	{
		count = misc_get_eqcount();
	}

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
				thd_sleep(200);
				break;
			}

			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
				if(type == 1)	{
					gold += (equipment[equiplist[sel]].cost * 0.5f);
					equiplist[sel] = 0;
					misc_sort_equip();
					count = misc_get_eqcount();
				}
				else if(type == 0)	{
					gold += (items[itemlist[sel].number - 1].cost * 0.5f);
					itemlist[sel].count--;
					if(itemlist[sel].count == 0)	{
						itemlist[sel].number = 0;
					}
					misc_sort_items();
					count = misc_get_itcount();
				}
				time_since = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				if(sel < count - 1)	{
					sel++;
					if(sel - offset >= 19)	{
						offset++;
					}
				}
				time_since = timer_ms_gettime64();
			}

			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				if(sel > 0)	{
					sel--;
					if(sel - offset < 0)	{
						offset--;
					}
				}
				time_since = timer_ms_gettime64();
			}
		}

		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);

		shop_basic_lines();
		shop_basic_arrow(1);

		if(type == 1)	{
			shop_equipment_lines();
		}

		shop_buysell_lines();
		shop_buysell_arrow(sel - offset);

		plx_list_begin(PLX_LIST_TR_POLY);
		shop_draw_title(name);
		shop_basic_text();
		if(type == 1)	{
			shop_equipment_info(equiplist[sel]);
			shop_buysell_names1(equiplist, count, offset, 1); 
		}
		else	{
			shop_buysell_names2(count, offset);
		}
		shop_buysell_gold();
		plx_scene_end();
	}
}

void shop_open(area_t * cur_area, uint8 shopnum)	{
	cont_state_t * state;
	int sel = 0;
	uint64 time_since = timer_ms_gettime64();
	shop_t * shop = &cur_area->shop[shopnum];

	while(1)	{
		state = (cont_state_t *) maple_dev_status(maple_enum_type(0, MAPLE_FUNC_CONTROLLER));

		if(state != NULL)	{
			if(state->buttons & CONT_A && time_since + 200 < timer_ms_gettime64())	{
				if(sel == 0)	{
					shop_buy(shop->items, shop->itemcount, shop->name, shop->type);
				}
				else if(sel == 1)	{
					shop_sell(shop->type, shop->name);
				}
				else	{
					break;
				}
				time_since = timer_ms_gettime64();
			}

			if(state->buttons & CONT_B && time_since + 200 < timer_ms_gettime64())	{
				break;
			}

			if(state->buttons & CONT_DPAD_DOWN && time_since + 200 < timer_ms_gettime64())	{
				if(sel != 2)	{
					sel++;
				}
				else	{
					sel = 0;
				}
				time_since = timer_ms_gettime64();
			}
			if(state->buttons & CONT_DPAD_UP && time_since + 200 < timer_ms_gettime64())	{
				if(sel != 0)	{
					sel--;
				}
				else	{
					sel = 2;
				}
				time_since = timer_ms_gettime64();
			}
			
		}
		plx_scene_begin();
		plx_list_begin(PLX_LIST_OP_POLY);
		
		shop_basic_lines();
		shop_basic_arrow(sel);
		
		plx_list_begin(PLX_LIST_TR_POLY);
		
		shop_basic_text();
		shop_draw_title(shop->name);
		plx_scene_end();
	}
}

