/*	xmlhnd.c -- ljsdcdev
	XML Parser callback thingymabobs
	ljsdcdev
	Copyright (C) 2003 Lawrence Sebald

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ljsdcdev.h"

static int counter = 0;
static int counter2 = 0;
static int enem_open = 0;

static void it_xml_start(void *userData, const char *name, const char **atts)	{
	int i;

	if(!strcmp(name, "COUNT"))	{
		items = (item_desc_t *) malloc(sizeof(item_desc_t) * atoi(atts[1]));
	}

	if(!strcmp(name, "ITEM"))	{
		for(i = 0; atts[i]; i += 2)	{
			if(!strcmp(atts[i], "NAME"))	{
				items[counter].name = (char *) malloc(strlen(atts[i + 1]) + 1);
				strcpy(items[counter].name, atts[i + 1]);
			}
			else if(!strcmp(atts[i], "STR"))	{
				items[counter].str = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "TYPE"))	{
				items[counter].typ = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "EFF"))	{
				items[counter].eff = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "AFF"))	{
				items[counter].aff = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "COST"))	{
				items[counter].cost = atoi(atts[i + 1]);
			}
		}
	}
}

static void it_xml_end(void *userData, const char *name)	{
	if(!strcmp(name, "ITEM"))	{
		counter++;
	}
}

static void mag_xml_start(void *userData, const char *name, const char **atts)	{
	int i;

	if(!strcmp(name, "COUNT"))	{
		magics = (mag_desc_t *) malloc(sizeof(mag_desc_t) * atoi(atts[1]));
	}

	if(!strcmp(name, "MAGIC"))	{
		for(i = 0; atts[i]; i += 2)	{
			if(!strcmp(atts[i], "NAME"))	{
				magics[counter].name = (char *) malloc(strlen(atts[i + 1]) + 1);
				strcpy(magics[counter].name, atts[i + 1]);
			}
			else if(!strcmp(atts[i], "STR"))	{
				magics[counter].str = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "TYPE"))	{
				magics[counter].typ = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "LEVEL"))	{
				magics[counter].lev = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "AFF"))	{
				magics[counter].aff = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "STAT"))	{
				magics[counter].stat = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "COST"))	{
				magics[counter].cost = atoi(atts[i + 1]);
			}
		}
	}
}

static void mag_xml_end(void *userData, const char *name)	{
	if(!strcmp(name, "MAGIC"))	{
		counter++;
	}
}

static void skill_xml_start(void *userData, const char *name, const char **atts)	{
	int i;

	if(!strcmp(name, "COUNT"))	{
		skills = (skill_desc_t *) malloc(sizeof(skill_desc_t) * atoi(atts[1]));
		skill_count = atoi(atts[1]);
	}

	if(!strcmp(name, "SKILL"))	{
		counter2 = 0;
		for(i = 0; atts[i]; i += 2)	{
			if(!strcmp(atts[i], "NAME"))	{
				skills[counter].name = (char *) malloc(strlen(atts[i + 1]) + 1);
				strcpy(skills[counter].name, atts[i + 1]);
			}
			else if(!strcmp(atts[i], "STR"))	{
				skills[counter].str = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "TYPE"))	{
				skills[counter].typ = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "EFF"))	{
				skills[counter].eff = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "AFF"))	{
				skills[counter].aff = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "REQS"))	{
				skills[counter].req_count = atoi(atts[i + 1]);
				skills[counter].req = (uint16 *) malloc(sizeof(uint16) * skills[counter].req_count);
			}
			else if(!strcmp(atts[i], "SXP"))	{
				skills[counter].sxp_req = atoi(atts[i + 1]);
			}
		}
	}
	if(!strcmp(name, "REQ"))	{
		skills[counter].req[counter2] = atoi(atts[1]);
	}
}

static void skill_xml_end(void *userData, const char *name)	{
	if(!strcmp(name, "SKILL"))	{
		counter++;
	}
	if(!strcmp(name, "REQ"))	{
		counter2++;
	}
}

static void equip_xml_start(void *userData, const char *name, const char **atts)	{
	int i;

	if(!strcmp(name, "COUNT"))	{
		equipment = (equip_desc_t *) malloc(sizeof(equip_desc_t) * (atoi(atts[1]) + 1));
		equipment[0].name = (char *) malloc(8);
		strcpy(equipment[0].name, "Nothing");
		equipment[0].str_req = 0;
		equipment[0].att = 0;
		equipment[0].def = 0;
		equipment[0].spd = 0;
		equipment[0].intl = 0;
		equipment[0].acc = 0;
		equipment[0].where = 0;
		equipment[0].cost = 0;

		counter = 1;
	}

	if(!strcmp(name, "EQUIP"))	{
		for(i = 0; atts[i]; i += 2)	{
			if(!strcmp(atts[i], "NAME"))	{
				equipment[counter].name = (char *) malloc(strlen(atts[i + 1]) + 1);
				strcpy(equipment[counter].name, atts[i + 1]);
			}
			else if(!strcmp(atts[i], "STR"))	{
				equipment[counter].str_req = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "ATT"))	{
				equipment[counter].att = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "DEF"))	{
				equipment[counter].def = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "SPD"))	{
				equipment[counter].spd = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "INTL"))	{
				equipment[counter].intl = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "ACC"))	{
				equipment[counter].acc = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "WHERE"))	{
				equipment[counter].where = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "COST"))	{
				equipment[counter].cost = atoi(atts[i + 1]);
			}
		}
	}
}

static void equip_xml_end(void *userData, const char *name)	{
	if(!strcmp(name, "EQUIP"))	{
		counter++;
	}
}

static void enem_xml_start(void * userData, const char * name, const char ** atts)	{
	int i;

	if(!strcmp(name, "COUNT"))	{
		en_desc = (en_desc_t *) malloc(sizeof(en_desc_t) * atoi(atts[1]));
	}

	else if(!strcmp(name, "ENEMY"))	{
		for(i = 0; atts[i]; i += 2)	{
			if(!strcmp(atts[i], "NAME"))	{
				strcpy(en_desc[counter].name, atts[i + 1]);
			}
			else if(!strcmp(atts[i], "ATT"))	{
				en_desc[counter].attack = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "DEF"))	{
				en_desc[counter].defense = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "SPD"))	{
				en_desc[counter].speed = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "MDEF"))	{
				en_desc[counter].mdef = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "MATT"))	{
				en_desc[counter].matt = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "ACC"))	{
				en_desc[counter].accuracy = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "HP"))	{
				en_desc[counter].hp = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "MP"))	{
				en_desc[counter].mp = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "ELEM"))	{
				en_desc[counter].element = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "EXP"))	{
				en_desc[counter].exp = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "GOLD"))	{
				en_desc[counter].gold = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "SXP"))	{
				en_desc[counter].sxp = atoi(atts[i + 1]);
			}
			else if(!strcmp(atts[i], "FN"))	{
				strcpy(en_desc[counter].fn, atts[i + 1]);
			}
		}
		enem_open = 1;
		en_desc[counter].magics[0] = 0;
		en_desc[counter].magics[1] = 0;
		en_desc[counter].magics[2] = 0;
		en_desc[counter].magics[3] = 0;
	}

	else if(!strcmp(name, "MAGIC") && enem_open == 1)	{
		en_desc[counter].magics[counter2] = atoi(atts[1]);
	}
}

static void enem_xml_end(void *userData, const char *name)	{
	if(!strcmp(name, "ENEMY"))	{
		counter++;
		enem_open = 0;
		counter2 = 0;
	}
	else if(!strcmp(name, "MAGIC"))	{
		counter2++;
	}
}

static void cred_xml_start(void * userData, const char * name, const char ** atts)	{
	int i;
	
	if(!strcmp(name, "COUNT"))	{
		credits = (credit_t *) malloc(sizeof(credit_t) * (atoi(atts[1]) + 3));
		credits[0].section = (char *) malloc(20);
		credits[0].message = (char *) malloc(60);
		credits[0].imagefn = (char *) malloc(21);
		strcpy(credits[0].section, "ljsdcdev Engine:\0");
		strcpy(credits[0].message, "Programmed By:\n"
					   "Lawrence Sebald\n"
					   "ljsdcdev.sunsite.dk\0");
		strcpy(credits[0].imagefn, "/cd/images/smily.png");
		credits[1].section = credits[0].section;
		credits[1].message = (char *) malloc(256);
		credits[1].imagefn = credits[0].imagefn;
		strcpy(credits[1].message, "Special Thanks:\n"
					   "My Sister, and my parents\n"
					   "Everyone in #dreamcastdev\n"
					   "All my friends who put up with my rambling\n"
					   "The people of the DC sites and chat rooms\n    that I frequent\n"
					   "Dan Potter and the Cryptic Allusion Team\n    for creating KOS\n"
					   "Without all of you, none of this would be possible!\0");
		credits[2].section = credits[0].section;
		credits[2].message = (char *) malloc(40);
		credits[2].imagefn = credits[0].imagefn;
		strcpy(credits[2].message, "Copyright (C) 2002,2003 Lawrence Sebald\0");
		counter = 3;
		credits_count = 3;
	}
	
	else if(!strcmp(name, "CREDIT"))	{
		for(i = 0; atts[i]; i++)	{
			if(!strcmp(atts[i], "SECTION"))	{
				credits[counter].section = malloc(strlen(atts[i + 1]) + 1);
				strcpy(credits[counter].section, atts[i + 1]);
			}
			else if(!strcmp(atts[i], "MESSAGE"))	{
				credits[counter].message = malloc(strlen(atts[i + 1]) + 1);
				strcpy(credits[counter].message, atts[i + 1]);
			}
			else if(!strcmp(atts[i], "IMAGEFN"))	{
				credits[counter].imagefn = malloc(strlen(atts[i + 1]) + 1);
				strcpy(credits[counter].imagefn, atts[i + 1]);
			}
		}
	}
}

static void cred_xml_end(void *userData, const char *name)	{
	if(!strcmp(name, "CREDIT"))	{
		counter++;
		credits_count++;
	}
}

int xml_parse_type(int type)	{
	FILE * fp;
	XML_Parser xmlp = XML_ParserCreate(NULL);
	char * buf;
	unsigned long size;
	counter = 0;
	counter2 = 0;
	enem_open = 0;

	if(type == 0)	{
		XML_SetElementHandler(xmlp, it_xml_start, it_xml_end);
		fp = fopen("/cd/data/items.xml", "r");
	}
	else if(type == 1)	{
		XML_SetElementHandler(xmlp, mag_xml_start, mag_xml_end);
		fp = fopen("/cd/data/magics.xml", "r");
	}
	else if(type == 2)	{
		XML_SetElementHandler(xmlp, skill_xml_start, skill_xml_end);
		fp = fopen("/cd/data/skills.xml", "r");
	}
	else if(type == 3)	{
		XML_SetElementHandler(xmlp, equip_xml_start, equip_xml_end);
		fp = fopen("/cd/data/equip.xml", "r");
	}
	else if(type == 4)	{
		XML_SetElementHandler(xmlp, enem_xml_start, enem_xml_end);
		fp = fopen("/cd/data/enem.xml", "r");
	}
	else if(type == 5)	{
		XML_SetElementHandler(xmlp, cred_xml_start, cred_xml_end);
		fp = fopen("/cd/data/credits.xml", "r");
	}
	else	{
		printf("xml_parse_type: Invalid type!\n");
		return 1;
	}

	size = misc_get_filesize(fp);
	buf = (char *) malloc(size);
	fread(buf, size, 1, fp);
	fclose(fp);

	if (XML_Parse(xmlp, buf, size, 1) == XML_STATUS_ERROR) {
		printf("%s at line %d\n", XML_ErrorString(XML_GetErrorCode(xmlp)),
				XML_GetCurrentLineNumber(xmlp));
		return 1;
	}
	XML_ParserFree(xmlp);
	free(buf);

	return 0;
}
